//For choices during dialogues -- a choice is a prompt, and the result when that prompt is clicked
class Choice extends Clickable {
  
  String choiceText; //The text that is prompted
  String choiceResult; //The text that is given as a result
  
  Choice(String text, String result){
    super("ChoiceIcon.png");
    choiceText = text;
    choiceResult = result;
  }
  
  void onClick(){
    setStatus(choiceResult);
  }
    
}

void prepareChoices(){ //Initializes the choice system
  
  choiceArray = new Choice[4]; //Max of 4 choices
  choiceX = new int[] { 10, 235, 460, 685 }; //Positioning in dialogue box
  
  for (int i = 0; i < 4; i++) {
      choiceArray[i] = new Choice("", "");  
      choiceArray[i].clk_x = choiceX[i];
      choiceArray[i].clk_y = 560;
   }
}

void clearChoices(){ //Clears the choice array
   for (int i = 0; i < 4; i++) {
      choiceArray[i].choiceText = "";
      choiceArray[i].choiceResult = "";
   }
}

//Adds a choice
void addChoice(int num, String text, String result){
  choiceArray[num].choiceText = text;
  choiceArray[num].choiceResult = result;
}
