void setupGUI(){
  
  GUI = new Room("GUI", false, #ffffff, #ffffff, true);
  Map = new Room("Map", false, #ffffff, #ffffff, true);
    Map.noFloor();
  
  lensButton = new LensButton("GlassButton2.png");
  talkButton = new TalkButton("TalkButton2.png");
  measureButton = new MeasureButton("MeasureButton2.png");
  weighButton = new WeighButton("WeighButton2.png");
  mapButton = new Door("MapButton2.png", Map, "");
  IntroButton = new Door("IntroButton2.png", intro, "");
  oReportButton = new ReportButton("ReportButton2.png");
  oMapScreen = new MapScreen("MapScreen.png");
  oCaseHintButton = new CaseHintButton("CaseHintButton2.png");
  oMathHintButton = new MathHintButton("MathHintButton2.png");
  
  
  Map.addObject(oMapScreen, 5, 5);
  Map.addObject(exitX, 825, 5);
  
  //Added when they access the computer
  emailIconGUI = new Door("EmailButton2.png", email, "");
  checkInIconGUI = new Door("CheckInButton2.png", check_in, "");
  inventoryIconGUI = new Door("SupplyButton2.png", supply_inventory, "");
  footprintGUI = new Door("FootprintButton2.png", FullFootprint, "");
  
  GUI.addObject(lensButton, 900, 0);
  GUI.addObject(talkButton, 1050, 0);
  GUI.addObject(measureButton, 900, 150);
  GUI.addObject(weighButton, 1050, 150);
  GUI.addObject(mapButton, 900, 300);
  GUI.addObject(IntroButton, 1000, 300);
  GUI.addObject(oCaseHintButton, 900, 500);
  GUI.addObject(oMathHintButton, 1000, 500);
  GUI.addObject(oReportButton, 1100, 500);
  
}

class LensButton extends Clickable {
  
  LensButton(String filename){
    super(filename);
  }
  
  void onClick(){
    cur_tool = "lens";
    cursor(GlassCursor, 0, 0);
  }
}

class TalkButton extends Clickable {
  
  TalkButton(String filename){
    super(filename);
  }
  
  void onClick(){
    cur_tool = "talk";
    cursor(TalkCursor, 0, 0);
  }
}

class MeasureButton extends Clickable {
  
  MeasureButton(String filename){
    super(filename);
  }
  
  void onClick(){
    cur_tool = "measure";
    cursor(MeasureCursor, 0, 0);
  }
}

class WeighButton extends Clickable {
  
  WeighButton(String filename){
    super(filename);
  }
  
  void onClick(){
    cur_tool = "weigh";
    cursor(WeighCursor, 0, 0);
  }
}

class ReportButton extends Clickable {
 
  ReportButton(String filename){
    super(filename);
  }
  
  void onClick(){
    goToRoom(Report);
    cp5.show();
  }
}

class MathHintButton extends Clickable {
  
  MathHintButton(String filename){
    super(filename);
  }
  
  void onClick(){
    super.onClick();
    setStatus("Ada: \"" + math_hint + "\"");
  }
}

class CaseHintButton extends Clickable {
  
  CaseHintButton(String filename){
    super(filename);
  }
  
  void onClick(){
    super.onClick();
    getCaseHint();
  }
}

void getCaseHint() {
      clearChoices();
      setStatus("Isaac: \"How can I help, detective?\"");
      
      //FORGERIES HELP
      addChoice(0, "I can't figure out\nwhich things are fake.", "Isaac: \"Examine each item to read the museum's description of it. A lousy copy may not match the description exactly.\nYou can ask Ada for help analyzing the objects, too.\"");
      
      //TIMING LEAD
      if (!saw_clock && password_status < 3) {  
        addChoice(1, "How can I figure out\nwho's a suspect?", "Isaac: \"Only museum employees have been in and out. We know that much.\nWe should figure out who was here when the burglary happened. First, we need to know when that was.\"");
      } else if (saw_clock && password_status < 3) {
        addChoice(1, "How can I figure out\nwho's a suspect?", "Isaac: \"Only museum employees have been in and out. We know that much.\nThat clock in the security office stopped when the burglary was happening last night. Let's figure out who was here at that time.\"");
      } else if (!saw_clock && password_status == 3) {
        addChoice(1, "How can I figure out\nwho's a suspect?", "Isaac: \"The computer log tells us who was here when last night. Could we figure out when the burglary happened?\nIf we knew that, we could figure out who was here at the exact time the crime occurred.\"");
      } else {
        addChoice(1, "How can I figure out\nwho's a suspect?", "Isaac: \"That clock in the security office stopped when the burglary happened. The computer check-in log tells us who was here when last night.\nIf we compare the log against the clock, we can figure out who was here at the time of the burglary.\"");
      }
      
      //SECURITY LEAD
      if (!saw_wires) {
       addChoice(2, "How did the burglar\ncut the security system?", "Isaac: \"We should go to the security office and take a look at the damage ourselves.\""); 
      } else {
       addChoice(2, "How did the burglar\ncut the security wires?", "Isaac: \"The wires the burglar cut are really high up! They must have stood on something, then raised their arms to snip the wires with a tool.\nCould that tell us anything about how tall the burglar is? Can we figure out what they stood on and what they used to cut the wires?\"");
      }
      
      //COMPUTER LEAD
      if (password_status == 1) {
        addChoice(3, "I don't know the password to\nthe computer.", "Isaac: \"It's Phil's computer. You should ask him.\"");
      } else if (password_status == 2) {
        addChoice(3, "When was Theodore Mathson's\ndog born?", "Isaac: \"I think I saw a painting with that dog in it somewhere in the museum.\"");
      } else if (password_status == 3) {
        addChoice(3, "What do you think of\nthe computer documents?", "Isaac: \"That timesheet is definitely useful for knowing who was here last night. And that inventory could show if anything's missing from the supply closet.\nIf anything's missing from the closet, the thief could have used it somewhere.\"");
      }
}
