import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import javax.swing.JOptionPane; 
import ddf.minim.*; 
import controlP5.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class MathDetective extends PApplet {

final int OBJ_LIMIT = 30;
final int WINDOW_WIDTH = 1200; //Need to update this manually at setup
final int WINDOW_HEIGHT = 600;





boolean MouseControl = false;
Minim minim;
AudioPlayer music, stepsound, doorsound;

ControlP5 cp5;
CheckBox items_checkbox;
RadioButton char_radio;
Textlabel items_label;
Textlabel suspects_label;
int report_tries;

String status;
String status2;
String cur_tool;
String math_hint;
boolean draw_floor;
PFont status_font;

Choice[] choiceArray;
int[] choiceX;

//Game flow
int password_status; //0 = new quest; 1 = noted locked computer; 2 = found dog clue; 3 = unlocked
int footprint_status; //0 = no footprint; 1 = NH only; 2 = supply only; 3 = both found;
boolean saw_clock;
boolean saw_wires;

Room prev_room;
Room cur_room;

Room GUI; //The GUI is actually just a room that is accessed differently -- but it's still just a collection of objects
MathHintButton oMathHintButton;
CaseHintButton oCaseHintButton;
Door IntroButton;
ReportButton oReportButton;
Inch  inchOverlap;

Room lobby;  //Main rooms
Room hallway;
Room paintings;
Room modern;
Room relics;
Room natural_history;
Room security;
Room closet;
Room giftshop;
Room cafe;
Room ending;

Room intro; //Minor rooms
Room crime;
Room instructions;
Room computer;
Room email;
Room supply_inventory;
Room check_in;
Room KnightRoom;
Room TrialRoom;
Room StillLifeRoom;
Room PortraitRoom;
Room MetamorphosisRoom;
Room CoinsRoom;
Room ChainRoom;
Room NHFootprint;
Room SupplyFootprint;
Room FullFootprint;
Room Map;
Room Report;

Object cur_object;

//Intro texts -- actually just giant doors to the next text room
Door introtext;
Door crimetext;
Door endingtext;
ExitX instructionstext; //This is an ExitX so that clicking through it always goes to prev room
ExitX exitX; //The universal "go to previous room" X

//GUI
LensButton lensButton;
TalkButton talkButton;
MeasureButton measureButton;
WeighButton weighButton;
Door emailIconGUI;
Door inventoryIconGUI;
Door checkInIconGUI;
Door footprintGUI;
NHFootprintScreen oNHFullFootprint;
SupplyFootprintScreen oSupplyFullFootprint;
Door mapButton;
MapScreen oMapScreen;

//Lobby
Desk oDesk;
Computer oComputer;
Door LobbyHallwayDoor;
Door LobbyDoor;
Door LobbyDoorLeft;
Door GiftShopDoor;
Door CafeDoor;

//Hallway
Door ExitToHallway;
Door ModernArtDoor;
Door RelicsDoor;
Door PaintingsDoor;
Door NaturalHistoryDoor;

//Lobby computer
Door emailIcon;
Door inventoryIcon;
Door checkInIcon;
Door computerExit;
EmailScreen oEmail;
InventoryScreen oSupplyInventory;
CheckInScreen oCheckIn;

//Paintings
MathsonPortrait oMathsonPortrait;
KnightPainting oKnightPainting;
StillLife oStillLife;
TrialPainting oTrialPainting;
PortraitArt oPortraitArt;
KnightArt oKnightArt;
StillLifeArt oStillLifeArt;
TrialArt oTrialArt;

//Modern
Cube oCube;
Metamorphosis oMetamorphosis;
Legs oLegs;
MetamorphosisArt oMetamorphosisArt;

//Relics
Chain oChain;
Coins oCoins;
Shield oShield;
Sign oSign;
CoinsScreen oCoinsScreen;
ChainScreen oChainScreen;

//Natural History
Bird oBird;
Dinosaur oDinosaur;
DinoFloor oDinoFloor;
Door SecurityDoor;
NHFootprintScreen oNHFootprint;

//Security
Clock oClock;
Garbage oGarbage;
Wires oWires;
Terminal oTerminal;
Door SecurityExit;

//Supply closet
Door SupplyExit;
Mop oMop1;
Mop oMop2;
Puddle oPuddle;
Bucket oBucket;
Stepladder oStepladder;
Hammer oHammer;
Screwdriver oScrewdriver;
Wrench oWrench;
Hook oHook;
SupplyFootprintScreen oSupplyFootprint;

//Gift shop
Counter oCounter;
ModelDinosaur oModelDinosaur;
Poster oPoster;
Minicube oMinicube;
Register oRegister;

//Cafe
Chair oChair1;
Chair oChair2;
CafeTable oCafeTable;
Coffee oCoffee;
CafeCounter oCafeCounter;
Door SupplyDoor;

//People
Director pDirector;
Receptionist pReceptionist;
Paintings pPaintings;
Modern pModern;
Scientist pScientist;
Security pSecurity;
Barista pBarista;
GiftShop pGiftShop;

PImage GlassCursor, TalkCursor, MeasureCursor, WeighCursor, ChoiceIcon;


public void setup() {
  
  password_status = 0;
  footprint_status = 0;
  saw_clock = false;
  draw_floor = false;
  saw_wires = false;
  
  GlassCursor = loadImage("/images/GlassCursor.png");
  TalkCursor = loadImage("/images/TalkCursor.png");
  MeasureCursor = loadImage("/images/MeasureCursor.png");
  WeighCursor = loadImage("/images/WeighCursor.png");
  ChoiceIcon = loadImage("/images/ChoiceIcon.png");
  
  surface.setTitle("Math Caper: Introduction");
  cur_tool = "lens";
  cursor(GlassCursor, 0, 0);
  minim = new Minim(this);
  music = minim.loadFile("MathCaperMusicV3.mp3");
  stepsound = minim.loadFile("Footstep.mp3");
  doorsound = minim.loadFile("DoorSound.mp3");
  music.loop();
  
  prepareChoices();
  createAllRooms();
  createAllObjects();
  addObjectsToRooms();
  setupGUI();
  setupReport();
  status_font = createFont("Lucida Sans", 12);
  textFont(status_font);
  setStatus("Welcome to Math Caper!");
  prev_room = lobby;
  cur_room = intro;
}

public void draw() {
  background(255);
    
  noStroke();
  fill(cur_room.wall_color);
  rect(0,0,900,400);
  fill(cur_room.floor_color);
  rect(0,400,900,100);
  
  stroke(0);
  strokeWeight(1);
  if (draw_floor) {
    line(0,400,900,400); //Floor line
  }
  
  strokeWeight(2);
  line(WINDOW_WIDTH * .75f ,0,WINDOW_WIDTH * .75f,WINDOW_HEIGHT); //Window is 900x500
  line(0,WINDOW_HEIGHT-100,WINDOW_WIDTH,WINDOW_HEIGHT-100);
  
  drawRoom(cur_room);
  drawChoices();
  if (cur_room.showGUI) {
    drawRoom(GUI);
  }
  fill(0);
  text(status,10,520);
  fill(0xff0000ff);
  text(status2, 10, 540);
  fill(0);
}

//Outputs to the game's text console
public void setStatus(String msg){
  status = msg;
  status2 = "";
}

public void setStatus(String msg, String msg2){
  status = msg;
  status2 = msg2;
}

public void clearStatus(){
  setStatus("", "");
}
//For choices during dialogues -- a choice is a prompt, and the result when that prompt is clicked
class Choice extends Clickable {
  
  String choiceText; //The text that is prompted
  String choiceResult; //The text that is given as a result
  
  Choice(String text, String result){
    super("ChoiceIcon.png");
    choiceText = text;
    choiceResult = result;
  }
  
  public void onClick(){
    setStatus(choiceResult);
  }
    
}

public void prepareChoices(){ //Initializes the choice system
  
  choiceArray = new Choice[4]; //Max of 4 choices
  choiceX = new int[] { 10, 235, 460, 685 }; //Positioning in dialogue box
  
  for (int i = 0; i < 4; i++) {
      choiceArray[i] = new Choice("", "");  
      choiceArray[i].clk_x = choiceX[i];
      choiceArray[i].clk_y = 560;
   }
}

public void clearChoices(){ //Clears the choice array
   for (int i = 0; i < 4; i++) {
      choiceArray[i].choiceText = "";
      choiceArray[i].choiceResult = "";
   }
}

//Adds a choice
public void addChoice(int num, String text, String result){
  choiceArray[num].choiceText = text;
  choiceArray[num].choiceResult = result;
}
//Any clickable item that appears on the game screen. Image determines mouse detection.
class Clickable {
  PImage clk_image;
  int clk_height;
  int clk_width;
  int clk_x;
  int clk_y;
  
  Clickable(String filename){
    String file = "/images/" + filename;
    clk_image = loadImage(file);
    clk_height = clk_image.height;
    clk_width = clk_image.width;
  }
  
  //Checks for click
  public boolean mouseOver(){
    return (mouseX > this.getX() && mouseX < this.getX()+this.getWidth() &&
       mouseY > this.getY() && mouseY < this.getY()+this.getHeight());
  }
  
  public void onClick(){
    clearChoices();
  }
  
  public PImage getImage() {
    return clk_image;
  }
  
  public int getHeight() {
    return clk_height;
  }
  
  public int getWidth() {
    return clk_width;
  }
  
  public int getX() {
    return clk_x;
  }
  
  public int getY() {
    return clk_y;
  }
    
}

//Objects in the game world, including people subclass)
class Object extends Clickable {
  String desc;
  String measure;
  String weigh;
  String mathhint;

  
  Object(String filename) {
    super(filename);
    desc = "";
    measure = "";
    weigh = "";
    mathhint = "";
  }
  
  public void onClick(){ //Check the current tool to see what information to get
   clearChoices();
   
   if (this.mathhint != "") {
     math_hint = this.mathhint;
   } else {
     math_hint = cur_room.mathhint;
   }
    
   cur_object = this;
   switch(cur_tool) {
    case "lens":
      this.getDesc();
      break;
    case "measure":
      this.getMeasure();
      break;
    case "weigh":
      this.getWeigh();
      break;
    }
  }
  
  public void getDesc() {
    setStatus(desc);
  }
  
  public void getMeasure() {
    setStatus(measure);
  }
  
  public void getWeigh() {
    setStatus(weigh);
  }
  
}

//Doors are Clickables that go to rooms when clicked
class Door extends Clickable {
  Room destination;
  String type;
  
  Door(String filename, Room dest, String sound_type){
    super(filename);
    destination = dest;
    type = sound_type;
  }
  
  public void onClick(){
    goToRoom(destination);
    if (type == "footstep"){
      stepsound.rewind();
      stepsound.play(1000);
    } else if (type == "door") {
      doorsound.rewind();
      doorsound.play();
    }
    
  }
}

public void mouseClicked(){
    
    boolean done = false; //The "done" system prevents "click-through" when an object in the next room is at the same location
    //Find the object clicked on in the room
    for (int i = 0; i < cur_room.num_obj; i++) {
     if (!done && cur_room.obj[i].mouseOver()){
       cur_room.obj[i].onClick();
       done = true;
     }
    }
    
    //Or find the the choice clicked in the dialogue area
    for (int i = 0; i < 4; i++) {
     if (!done && choiceArray[i].mouseOver()){
       choiceArray[i].onClick();
       done = true;
     }
    }
    
    //Or the GUI
    for (int i = 0; i < GUI.num_obj; i++) {
     if (cur_room.showGUI && !done && GUI.obj[i].mouseOver()){
       GUI.obj[i].onClick();
       done = true;
     }
    }

}


public void drawChoices(){
  
  for (int i = 0; i < 4; i++){
      if (choiceArray[i].choiceText != "") {
        image(ChoiceIcon, choiceX[i], 560);
        fill(0xff8F334D);
        text(choiceArray[i].choiceText, choiceX[i]+25, 570);
      }
  }
}

public void keyPressed() {
  
  //Number hotkeys for tools: 1 = lens, 2 = talk, 3 = measure, 4 = weigh
  switch(key) {
    case '1':
      cur_tool = "lens";
      cursor(GlassCursor, 0, 0);
      break;
    case '2':
      cur_tool = "talk";
      cursor(TalkCursor, 0, 0);
      break;
    case '3':
      cur_tool = "measure";
      cursor(MeasureCursor, 0, 0);
      break;
    case '4':
      cur_tool = "weigh";
      cursor(WeighCursor, 0, 0);
      break;
    case 'm':
      if (music.isPlaying()){
        music.pause();
      } else {
        music.loop();
      }
      break;
    //case 'p':
    //  goToRoom(paintings);
    //  break;
    //case 'l':
    //  goToRoom(lobby);
    //  break;
    //case 'm':
    //  goToRoom(modern);
    //  break;
    //case 'r':
    //  goToRoom(relics);
    //  break;
    //case 'n':
    //  goToRoom(natural_history);
    //  break;
    //case 's':
    //  goToRoom(security);
    //  break;
    //case 'g':
    //  goToRoom(giftshop);
    //  break;
    //case 'c':
    //  goToRoom(closet);
    //  break;
    //case 'e':
    //  goToRoom(cafe);
    //  break;
    //case 'f':
    //  goToRoom(FullFootprint);
    //  break;
    //case 'h':
    //  clearChoices();
    //  setStatus("Ada: \"" + math_hint + "\"");
    //  break;
    //case '/':
    //  goToRoom(intro);
    //  break;
    case 'z':
      goToRoom(Report);
      cp5.show();
      break;
    //case 'i':
    //  getCaseHint();
      
    //  break;
      
    }
  }
public void setupGUI(){
  
  GUI = new Room("GUI", false, 0xffffffff, 0xffffffff, true);
  Map = new Room("Map", false, 0xffffffff, 0xffffffff, true);
    Map.noFloor();
  
  lensButton = new LensButton("GlassButton2.png");
  talkButton = new TalkButton("TalkButton2.png");
  measureButton = new MeasureButton("MeasureButton2.png");
  weighButton = new WeighButton("WeighButton2.png");
  mapButton = new Door("MapButton2.png", Map, "");
  IntroButton = new Door("IntroButton2.png", intro, "");
  oReportButton = new ReportButton("ReportButton2.png");
  oMapScreen = new MapScreen("MapScreen.png");
  oCaseHintButton = new CaseHintButton("CaseHintButton2.png");
  oMathHintButton = new MathHintButton("MathHintButton2.png");
  
  
  Map.addObject(oMapScreen, 5, 5);
  Map.addObject(exitX, 825, 5);
  
  //Added when they access the computer
  emailIconGUI = new Door("EmailButton2.png", email, "");
  checkInIconGUI = new Door("CheckInButton2.png", check_in, "");
  inventoryIconGUI = new Door("SupplyButton2.png", supply_inventory, "");
  footprintGUI = new Door("FootprintButton2.png", FullFootprint, "");
  
  GUI.addObject(lensButton, 900, 0);
  GUI.addObject(talkButton, 1050, 0);
  GUI.addObject(measureButton, 900, 150);
  GUI.addObject(weighButton, 1050, 150);
  GUI.addObject(mapButton, 900, 300);
  GUI.addObject(IntroButton, 1000, 300);
  GUI.addObject(oCaseHintButton, 900, 500);
  GUI.addObject(oMathHintButton, 1000, 500);
  GUI.addObject(oReportButton, 1100, 500);
  
}

class LensButton extends Clickable {
  
  LensButton(String filename){
    super(filename);
  }
  
  public void onClick(){
    cur_tool = "lens";
    cursor(GlassCursor, 0, 0);
  }
}

class TalkButton extends Clickable {
  
  TalkButton(String filename){
    super(filename);
  }
  
  public void onClick(){
    cur_tool = "talk";
    cursor(TalkCursor, 0, 0);
  }
}

class MeasureButton extends Clickable {
  
  MeasureButton(String filename){
    super(filename);
  }
  
  public void onClick(){
    cur_tool = "measure";
    cursor(MeasureCursor, 0, 0);
  }
}

class WeighButton extends Clickable {
  
  WeighButton(String filename){
    super(filename);
  }
  
  public void onClick(){
    cur_tool = "weigh";
    cursor(WeighCursor, 0, 0);
  }
}

class ReportButton extends Clickable {
 
  ReportButton(String filename){
    super(filename);
  }
  
  public void onClick(){
    goToRoom(Report);
    cp5.show();
  }
}

class MathHintButton extends Clickable {
  
  MathHintButton(String filename){
    super(filename);
  }
  
  public void onClick(){
    super.onClick();
    setStatus("Ada: \"" + math_hint + "\"");
  }
}

class CaseHintButton extends Clickable {
  
  CaseHintButton(String filename){
    super(filename);
  }
  
  public void onClick(){
    super.onClick();
    getCaseHint();
  }
}

public void getCaseHint() {
      clearChoices();
      setStatus("Isaac: \"How can I help, detective?\"");
      
      //FORGERIES HELP
      addChoice(0, "I can't figure out\nwhich things are fake.", "Isaac: \"Examine each item to read the museum's description of it. A lousy copy may not match the description exactly.\nYou can ask Ada for help analyzing the objects, too.\"");
      
      //TIMING LEAD
      if (!saw_clock && password_status < 3) {  
        addChoice(1, "How can I figure out\nwho's a suspect?", "Isaac: \"Only museum employees have been in and out. We know that much.\nWe should figure out who was here when the burglary happened. First, we need to know when that was.\"");
      } else if (saw_clock && password_status < 3) {
        addChoice(1, "How can I figure out\nwho's a suspect?", "Isaac: \"Only museum employees have been in and out. We know that much.\nThat clock in the security office stopped when the burglary was happening last night. Let's figure out who was here at that time.\"");
      } else if (!saw_clock && password_status == 3) {
        addChoice(1, "How can I figure out\nwho's a suspect?", "Isaac: \"The computer log tells us who was here when last night. Could we figure out when the burglary happened?\nIf we knew that, we could figure out who was here at the exact time the crime occurred.\"");
      } else {
        addChoice(1, "How can I figure out\nwho's a suspect?", "Isaac: \"That clock in the security office stopped when the burglary happened. The computer check-in log tells us who was here when last night.\nIf we compare the log against the clock, we can figure out who was here at the time of the burglary.\"");
      }
      
      //SECURITY LEAD
      if (!saw_wires) {
       addChoice(2, "How did the burglar\ncut the security system?", "Isaac: \"We should go to the security office and take a look at the damage ourselves.\""); 
      } else {
       addChoice(2, "How did the burglar\ncut the security wires?", "Isaac: \"The wires the burglar cut are really high up! They must have stood on something, then raised their arms to snip the wires with a tool.\nCould that tell us anything about how tall the burglar is? Can we figure out what they stood on and what they used to cut the wires?\"");
      }
      
      //COMPUTER LEAD
      if (password_status == 1) {
        addChoice(3, "I don't know the password to\nthe computer.", "Isaac: \"It's Phil's computer. You should ask him.\"");
      } else if (password_status == 2) {
        addChoice(3, "When was Theodore Mathson's\ndog born?", "Isaac: \"I think I saw a painting with that dog in it somewhere in the museum.\"");
      } else if (password_status == 3) {
        addChoice(3, "What do you think of\nthe computer documents?", "Isaac: \"That timesheet is definitely useful for knowing who was here last night. And that inventory could show if anything's missing from the supply closet.\nIf anything's missing from the closet, the thief could have used it somewhere.\"");
      }
}


class Desk extends Object{
   
  Desk(String filename) {
    super(filename);
    clk_width /= 2; //The width is halved so clicking the computer won't trigger the desk.
    desc = "The front desk of the museum. There's a note on the desk: COMPUTER PASSWORD IS THE YEAR THEODORE MATHSON'S DOG WAS BORN";
    measure = "The desk is 30 inches tall, 48 inches wide, and 28 inches deep.";
    weigh = "The desk is too big to weigh on your small scale.";
   }
   
    public void getDesc(){
      super.getDesc();
      if (password_status <= 2) {
        password_status = 2;
        setStatus(status, "You should ask around about the dog's birthday.");
      }
    }
    
}

class Computer extends Object{
   
  Computer(String filename) {
    super(filename);
    desc = "It's locked with a password.";
    measure = "The monitor is 12 inches tall and 16 inches wide. The keyboard is 16 inches wide and 8 inches deep.";
    weigh = "The computer monitor weighs 7.2 pounds. The keyboard weighs 1.2 pounds.";
   }
   
    public void getDesc(){
      super.getDesc();
      if (password_status < 3) {
        String password = JOptionPane.showInputDialog(frame, "Enter password:", "Password Required", JOptionPane.PLAIN_MESSAGE);
        if (password != null && password.equals("1891")) {
          goToRoom(computer);
          password_status = 3;
          GUI.addObject(emailIconGUI, 900, 400);
          GUI.addObject(checkInIconGUI, 1000, 400);
          GUI.addObject(inventoryIconGUI, 1100, 400);
        } else {
          setStatus("Incorrect password. Access denied.");
          if (password_status == 0) {
            password_status = 1;
            setStatus(status, "You should ask about the password.");
          }
        }
      } else {
        goToRoom(computer);
      }
    }
    
}

class EmailScreen extends Object {
  
  EmailScreen(String filename) {
    super(filename);
    desc = "This is Phil's email account. Don't worry, you can snoop. It's your job.\n\nYou may reread this at any time from the clue menu at right.";
    measure = "The monitor is 12 inches tall and 16 inches wide.";
    weigh = "The computer monitor weighs 7.2 pounds.";
  }
  
}

class InventoryScreen extends Object {
  
  InventoryScreen(String filename) {
    super(filename);
    desc = "This is a list of what should be in the supply closet.\n\nYou may reread this at any time from the clue menu at right.";
    measure = "The monitor is 12 inches tall and 16 inches wide.";
    weigh = "The computer monitor weighs 7.2 pounds.";
  }
  
}

class CheckInScreen extends Object {
  
  CheckInScreen(String filename) {
    super(filename);
    desc = "It's a record of everyone who's been in and out of the museum.\n\nYou may reread this at any time from the clue menu at right.";
    measure = "The monitor is 12 inches tall and 16 inches wide.";
    weigh = "The computer monitor weighs 7.2 pounds.";
  }
  
}

class MathsonPortrait extends PortraitArt {
  
  MathsonPortrait(String filename) {
    super(filename);
  }
  
   public void getDesc() {
    goToRoom(PortraitRoom);
  }
  
}

class PortraitArt extends Object{
   PortraitArt(String filename) {
    super(filename);
    desc = "\"Mathson Family Portrait\" by Octavia Grey. 66 inches wide x 45 inches tall, acrylic on canvas, painted in 1903.\nThis portrait of our museum's namesake family was painted in honor of their dog Happy's twelfth birthday.\nTheodore and Annabelle Mathson appear with Happy and their 3 daughters Lauren, Clara, and Peg in their mansion sitting room.";
    measure = "The portrait is 5 feet 6 inches feet wide and 3 feet 9 inches feet tall.";
    weigh = "The portrait is much too big to weigh on your scale.";
    mathhint = "Huh. Looks like Theodore Mathson's dog turned 12 years old in 1903.";
  }
}

class KnightPainting extends KnightArt {
  
  KnightPainting(String filename) {
    super(filename);
  }
  
  public void getDesc() {
    goToRoom(KnightRoom);
  }
  
}

class KnightArt extends Object {
  KnightArt(String filename) {
    super(filename);
    desc = "\"The Knight of the Six Stars\" by Edgar Plumm. 24 in x 24 in, oil on canvas, painted in 1754.\nThis portrays the medieval legend of the Knight of the Six Stars, who protected the English village of Brownstones from bandits.\nHere he sits on his horse Comet, prepared to assault a bandit lair. The Knight was named for the six stars on his shield, armor, and banner.\nPlumm drew twice as a many stars in the night sky to commemorate the Knight's ancestors who provided the same protection before him.";
    measure = "The painting is 2 feet wide and 2 feet tall.";
    weigh = "The painting weighs 4.8 pounds.";
    mathhint = "So he's the Knight of SIX stars, and there should be TWICE as many in the sky. TWICE means we multiply by two...";
  }
}

class StillLife extends StillLifeArt {
  
  StillLife(String filename) {
    super(filename);
  }
  
   public void getDesc() {
    goToRoom(StillLifeRoom);
  }
}

class StillLifeArt extends Object {
  StillLifeArt(String filename) {
    super(filename);
    desc = "\"Still Life\" by Lizbeth Hamm. 10 inches each side, acrylic on canvas, painted in 1802.\nAn early Hamm still-life in the classic fruit bowl tradition.\nThe apple represents wisdom, the pear stands for growth,\nand there are half as many green grapes as red to represent the passage from youth to adulthood.";
    measure = "The painting is 10 inches tall and 10 inches wide.";
    weigh = "The painting weighs 3.1 pounds.";
    mathhint = "There should be half as many green grapes as red grapes. So there should be twice as many red grapes.";
  }
}

class TrialPainting extends TrialArt {
  
  TrialPainting(String filename) {
    super(filename);
  }
  
   public void getDesc() {
    goToRoom(TrialRoom);
  }
   
}

class TrialArt extends Object {
  TrialArt(String filename) {
    super(filename);
    desc = "\"The Trial of Anne von Syne\" by Margot the Younger. 40 inches wide x 15 inches tall, oil on canvas, painted in 1467.\nAnne von Syne before the court of Angveld, waiting to be judged for stealing the king's bread to feed her son.\nThe people around her are King Herbert of Angveld, Queen Angela of Angveld, their six court guards,\nthree judicial counselors, the bailiff and the sheriff, and nine royal magistrates.";
    measure = "The painting is 3 feet 4 inches wide and 1 foot 3 inches tall.";
    weigh = "The painting weighs 5.1 pounds.";
    mathhint = "I can't really tell who is who in this painting. But we can count how many there are! One, two, three...";
  }
}

class Cube extends Object {
  
  Cube(String filename) {
    super(filename);
    desc = "\"My Cube, My Sorrow\" by Melodia Hogwash. Plastic (1998).\nHogwash poured 216 cubic feet of plastic into a mold to create this mysterious block. She says it was inspired by her father, somehow.";
    measure = "The cube is 6 feet wide, 6 feet tall, and 6 feet deep.";
    weigh = "The cube is too heavy to lift onto your scale.";
    mathhint = "Cubic feet is the amount of volume, right? The volume of a cube is length times width times height, if I remember geometry class right.";
  }
}

class Metamorphosis extends MetamorphosisArt {
  
  Metamorphosis(String filename) {
    super(filename);
  }
  
  public void getDesc(){
    goToRoom(MetamorphosisRoom);
  }
}

class MetamorphosisArt extends Object {
  MetamorphosisArt(String filename){
    super(filename);
    desc = "\"Metamorphosis\" by Bernadette Le Poisson. Acrylic on canvas (2012). 25 in wide x 15 in tall. \nThe artist drew herself transforming into a fire hydrant over the course of eight hours. Le Poisson insists it represents her memory, somehow.";
    measure = "The painting is 2 feet 1 inch wide and 1 foot 3 inches tall.";
    weigh = "The painting weighs 4.9 pounds.";
    mathhint = "She starts at about 9:20, and finishes changing 8 hours later...wait, can we talk about how weird this painting is?";
  }
}

class Legs extends Object {
  
  Legs(String filename) {
    super(filename);
    desc = "\"Half of Me\" by Damien Wirst. Bronze (2016).\nWirst constructed these models of his own legs. They are, as advertised, half his height and, together, half his weight.\nWirst says that the piece is intended to feel \"apart, and yet whole,\" somehow.";
    measure = "Each leg is 3 feet 1 inch tall.";
    weigh = "The left leg weighs 47.5 pounds, and the right leg weighs 36.2 pounds.";
  }
}

class Chain extends ChainScreen {
  Chain(String filename) {
    super(filename);
  }
  
  public void getDesc(){
    goToRoom(ChainRoom);
  }
}

class ChainScreen extends Object {
 ChainScreen(String filename){
   super(filename);
   desc =  "The chain of King Asymptoth, who ruled Parabolia from 499-534 AD. Each of the 17 links in this 19-inch chain weighs 0.2 pounds!\nThat's because they're made of pure parabolite, a very heavy mineral.\nKing Asymptoth wore it at all times as a symbol of his strength--at the cost of his posture." ;
   measure = "The chain is 1 foot 7 inches long.";
   weigh = "The whole chain weighs 4.1 pounds.";
   mathhint = "Is there the right number of links in the chain? Is it the right length?\nAnd what about the weight? If each of 17 links weighs 0.2 pounds, and we multiply...";
  }
}

class Coins extends CoinsScreen {
  Coins(String filename) {
    super(filename);
  }
  
  public void getDesc(){
    goToRoom(CoinsRoom);
  }
}

class CoinsScreen extends Object {
  CoinsScreen(String filename) {
    super(filename);
    desc = "Parabolaen coins, c. 525 AD. The numbers on the coins tell their value. Together these coins were worth 53 units of currency.";
    measure = "Each coin is a circle 1 inch across.";
    weigh = "Each coin weighs only 0.02 pounds.";
    mathhint = "The key on the right tells us how much each coin is worth. They should be worth 53 all together, so we add their values...";
  }
}

class Shield extends Object {
  Shield(String filename) {
    super(filename);
    desc =  "A shield used by a Parabolaen warrior. This 10-square-foot shield was lightweight (only 7-8 pounds) but sturdy enough for deflecting enemy arrows.";
    measure = "The shield is 2 feet wide and 5 feet tall.";
    weigh = "The shield weighs 7.7 pounds.";
    mathhint = "Have you checked the weight of the shield? And the area? The shield is a rectangle, so the area should just be base times height.";
  }
}

class Sign extends Object {
  Sign(String filename) {
    super(filename);
    desc = "The sign says \"The Parabolae were an ancient civilization that founded the modern nation of Parabolia some 1500 years ago.\nThe Mathson collection is proud to present this collection of relics, recently uncovered by archaeologists.\"";
    measure = "The sign is 6 feet 3 inches tall and 2 feet 1 inch wide.";
    weigh = "The sign weighs 11.2 pounds.";
  }
}

class Bird extends Object {
   Bird (String filename) {
    super(filename);
     desc = "A rare Blue-beaked falcon, now sadly extinct. This fearsome bird could weigh up to 25 pounds, and each of its wings could be up to 2 feet long!";
     measure = "The falcon's wingspan is 3 feet 6 inches. It's 20 inches tall.";
     weigh = "The falcon weighs 21.4 pounds.";
     mathhint = "If each wing could be upto two feet long, then together the wingspan should be twice that--at most, that is.";
   }
}

class Dinosaur extends Object {
  Dinosaur(String filename) {
    super(filename);
    desc = "Algebrasaurus X lived 80 million years ago. It could grow to be over 20 feet tall and weighed up to 5,000 pounds!";
    measure = "The dinosaur skeleton is 23 feet and 5 inches tall. Wow!";
    weigh = "You definitely can't weigh something that big.";
    mathhint = "It would be fun to measure this, but, to be honest, I sincerely doubt the burglar faked an entire dinosaur.";
  }
}

class DinoFloor extends Object {
  DinoFloor(String filename) {
    super(filename);
    desc = "This is the dinosaur display area. There's half a footprint next to one of the rocks in the sand.";
    measure = "The dinosaur display area is 20 feet across.";
    weigh = "You try to weigh the ground. You quickly realize that that doesn't work.";
  }
  
  public void getDesc() {
   goToRoom(NHFootprint); 
    
    if (footprint_status == 0){
      footprint_status = 1;
      footprintGUI.destination = NHFootprint;
      GUI.addObject(footprintGUI, 1100, 300);
      setStatus(NHFootprint.announcement, "You may view the footprint from the menu to your right.");
    } else if (footprint_status == 2){
      footprint_status = 3;
      footprintGUI.destination = FullFootprint;
    }
    
    if (footprint_status == 3) {
      setStatus(NHFootprint.announcement, "You may view the FULL footprint from the menu to your right.");
    }
  }
}

class NHFootprintScreen extends Object {
  NHFootprintScreen(String filename) {
    super(filename);
    desc = "It's the back of an incomplete footprint in the sand of the dinosaur display.";
    measure = "This piece of the footprint is 5.7 inches long.";
    weigh = "You can't weigh a footprint.";
    mathhint = "We can measure this, but that doesn't help when we've only got part of a footprint.";
  }
}

class ModelDinosaur extends Object {
  ModelDinosaur(String filename) {
    super(filename);
    desc = "That's a 1/10 scale model of the Algebrasaurus X.";
    measure = "The model is a little over 28 inches tall.";
    weigh = "The model weighs 4.2 pounds.";
    mathhint = "A 1/10 scale model should be one-tenth the height of the real thing.";
  }
}

class Poster extends Object {
  Poster(String filename) {
    super(filename);
    desc = "That's a poster of the \"Knight of the Six Stars\" painting.";
    measure = "The poster is 2 feet on each side.";
    weigh = "The poster only weighs 0.2 pounds.";
  }
}

class Minicube extends Object {
  Minicube(String filename) {
    super(filename);
    desc = "Those are miniature models of the cube in the modern art gallery.";
    measure = "The cubes are 2 inches on each side.";
    weigh = "A cube weighs 0.05 pounds.";
  }
}

class Mug extends Object {
  Mug(String filename) {
    super(filename);
    desc = "A mug with the museum logo on it.";
    measure = "The mug is 5 inches tall and 3 inches across.";
    weigh = "The mug weighs 0.2 pounds.";
  }
}

class Register extends Object {
  Register(String filename) {
    super(filename);
    desc = "It's a cash register. There's no money inside.";
    measure = "The register is 1 foot 11 inches tall.";
    weigh = "The register weighs 15.3 pounds.";
  }
}

class Counter extends Object {
    Counter(String filename) {
    super(filename);
    desc = "It's a counter. For doing business, not for counting. That's your job, detective.";
    measure = "The counter is 4 feet 2 inches tall.";
    weigh = "The counter is firmly attached to the ground.";
  }
}

class Wires extends Object {
  Wires(String filename) {
    super(filename);
    desc = "There are wires along the ceiling connected to the security terminal. It looks like they've been cut!";
    measure = "You extend your measuring tape very long and find that the wires are 14 feet off the ground.";
    weigh = "You can't weigh something stuck to the ceiling.";
  }
  
  public void getDesc(){
    setStatus("There are wires along the ceiling connected to the security terminal. It looks like they've been cut!", "The wires are very high off the ground. The burglar must have reached upward to cut these wires.\nYou can now measure suspects with their arms reaching upward.");
  }
  
  public void onClick() {
    super.onClick();
    saw_wires = true;
  }
}

class Clock extends Object {
  Clock(String filename) {
    super(filename);
    desc = "It's a wall clock wired into the wall. It looks like it's stopped.";
    measure = "The clock is 1 foot 6 inches across.";
    weigh = "The clock is wired into the wall. You can't take it down to weigh.";
  }
}

class Garbage extends Object {
  Garbage(String filename) {
    super(filename);
    desc = "It's a garbage pail. There are two paper wrappers inside with sugar crumbs.";
    measure = "The pail is 1 foot 8 inches tall. Its brim is 1 foot 1 inch across.";
    weigh = "The garbage pail weighs 1.2 pounds.";
  }
}

class Terminal extends Object {
  Terminal(String filename) {
    super(filename);
    desc = "It's a complicated security system. It looks like it's broken.";
    measure = "The system is 10 feet 2 inches tall.";
    weigh = "You can't weigh something so big.";
  }
}

class Mop extends Object {
  Mop(String filename) {
    super(filename);
    desc = "It's a mop.";
    measure = "The mop is 5 feet long.";
    weigh = "The mop weighs 4.3 pounds.";
  }
}

class Stepladder extends Object {
  Stepladder(String filename) {
    super(filename);
    desc = "It's a step ladder.";
    measure = "The step ladder is 3 feet tall.";
    weigh = "The step ladder weighs 6.5 pounds.";
  }
}

class Bucket extends Object {
  Bucket(String filename) {
    super(filename);
    desc = "It's a bucket for cleaning floors.";
    measure = "The bucket is 2 feet 2 inches tall and 1 foot 6 inches across.";
    weigh = "The bucket weighs 3.8 pounds.";
  }
}

class Puddle extends Object {
  Puddle(String filename) {
    super(filename);
    desc = "There's a puddle of water under that mop. There's a bit of a footprint sticking out.";
    measure = "The puddle is about 2 feet 3 inches across.";
    weigh = "You try to weigh the puddle. Your scale gets all wet.";
  }
  
  public void getDesc() {
    goToRoom(SupplyFootprint);
    
    if (footprint_status == 0){
      footprint_status = 2;
      footprintGUI.destination = SupplyFootprint;
      GUI.addObject(footprintGUI, 1100, 300);
      setStatus(SupplyFootprint.announcement, "You may view the footprint from the menu to your right.");
    } else if (footprint_status == 1){
      footprint_status = 3;
      footprintGUI.destination = FullFootprint;
    }
    
    if (footprint_status == 3) {
      setStatus(SupplyFootprint.announcement, "You may view the FULL footprint from the menu to your right.");
    }
  }
  
}

class SupplyFootprintScreen extends Object {
  SupplyFootprintScreen(String filename) {
    super(filename);
    desc = "It's the front of an incomplete footprint next to the puddle on the floor.";
    measure = "This piece of the footprint is 4.3 inches long.";
    weigh = "You can't weigh a footprint.";
    mathhint = "We can measure this, but that doesn't help when we've only got part of a footprint.";
  }
}

class Hammer extends Object {
  Hammer(String filename) {
    super(filename);
    desc = "A hammer hangs on the wall.";
    measure = "The hammer is 11 inches long.";
    weigh = "The hammer weighs 1.8 pounds.";
  }
}

class Screwdriver extends Object {
  Screwdriver(String filename) {
    super(filename);
    desc = "It's a screwdriver hanging on the wall.";
    measure = "The screwdriver is 8 inches long.";
    weigh = "The screwdriver weighs 0.56 pounds.";
  }
}

class Wrench extends Object {
  Wrench(String filename) {
    super(filename);
    desc = "There's a wrench hanging on the wall.";
    measure = "The wrench is 1 foot 3 inches long.";
    weigh = "The wrench weighs 3.2 pounds.";
  }
}

class Hook extends Object {
  Hook(String filename) {
    super(filename);
    desc = "There's a hook with nothing on it.";
    measure = "The hook sticks out 2 inches.";
    weigh = "You can't weigh a hook stuck in the wall.";
  }
}

class CafeTable extends Object {
  CafeTable(String filename) {
    super(filename);
    desc = "It's a table for eating at the cafe.";
    measure = "The table is 2 feet 6 inches tall. Its surface is a 3-foot square.";
    weigh = "The table weighs 14.34 pounds.";
  }
}

class Chair extends Object {
  Chair(String filename) {
    super(filename);
    desc = "It's a chair for eating. (For eating food, not the chair.)";
    measure = "The chair is 3 feet tall.";
    weigh = "The chair weighs 10.3 pounds.";
  }
}

class Coffee extends Object {
  Coffee(String filename) {
    super(filename);
    desc = "It's a canister for coffee. It's pretty hot!";
    measure = "The coffee canister is 2 feet 4 inches tall.";
    weigh = "You try to weigh the canister but just spill coffee instead.";
  }
}

class CafeCounter extends Object {
  CafeCounter(String filename) {
    super(filename);
    desc = "It's the cafe counter, full of all sorts of treats.";
    measure = "The counter is 8 feet long and 4 feet tall.";
    weigh = "You try to weigh the counter. You can't, so you weigh a piece of toast instead. It's 0.03 pounds.";
  }
}

class MapScreen extends Object {
  MapScreen(String filename) {
    super(filename);
    desc = "This is the map of the museum.";
    measure = "The map is 6 inches by 6 inches.";
    weigh = "The paper map doesn't even register on your scale.";
  }
}

class Inch extends Clickable {
  Inch(String filename) {
    super(filename);
  }
  
  public void onClick(){
    setStatus("There's an inch of overlap between the footprints.");
  }
}
    
class Person extends Object {
    String talk;
    String name;
    int height_ft;
    int height_in;
    int arms_ft;
    int arms_in;
    int foot_length_in;
    int char_weight;
    
    Person(String filename) {
    super(filename);
      talk = "";
    }
    
    public void onClick(){
      if (cur_tool == "talk") {
        clearChoices();
        getTalk();
      } else {
        super.onClick();
      }
    }
    
    public void getTalk() {
      setStatus(talk);
    }
    
    public void getMeasure() {
      setStatus("How would you like to measure " + name + "?");
      addChoice(0, "Measure height from head to toe", name + " is " + height_ft + " feet and " + height_in + " inches tall.");
      
      if (footprint_status > 0) {
        addChoice(1, "Measure foot length", name + "'s foot is " + foot_length_in + " inches long.\nIt's not the same pattern as the footprint.");
      }
      if (saw_wires) {
        addChoice(2, "Measure height with arms reaching up", name + " is " + arms_ft + " feet and " + arms_in + " inches tall when they reach with their arms.");
      }
    }
    
    public void getWeigh(){
      setStatus(name + " weighs " + char_weight + " pounds.");
    }
    
}

class Director extends Person {
  
  Director(String filename) {
    super(filename);
    name = "Angela";
    height_ft = 6;
    height_in = 1;
    arms_ft = 8;
    arms_in = 5;
    foot_length_in = 10;
    char_weight = 172;
    desc = "That's Angela St. Claire, the director of the Mathsonian museum. She's in charge of everything here.";
    talk = "\"Thank goodness you're here. I'm Angela St. Claire, director here at the museum. I'll help in any way I can.\"";
  }
  
  public void getTalk() {
    super.getTalk();
    addChoice(0, "Were you here last night?", "\"I was here late last night. I left at about midnight. I didn't see anything, though.\"");
    addChoice(1, "What can you tell me\nabout the incident?", "\"Only the museum workers have been in or out of the building. Our building has a system that requires us to log in or out whenever we leave.\nThe record is on Phil's computer here in the lobby. Since there was no break-in, I bet that could help.\"");
    if (password_status == 1) {
      addChoice(2, "What's the password to the computer?", "\"I'm not sure. It's Phil's computer, not mine.\"");
    }
    if (password_status == 2) {
      addChoice(2, "When was Theodore\nMathson's dog born?", "\"Oh, I don't know. Sometime in the 1800s, I guess.\"");
    }
  }
  
}

class Receptionist extends Person {
    Receptionist(String filename) {
    super(filename);
    name = "Phil";
    height_ft = 5;
    height_in = 8;
    arms_ft = 7;
    arms_in = 9;
    foot_length_in = 9;
    char_weight = 180;
    desc = "That's Phil Rudolph, the front desk receptionist at the museum.";
    talk = "\"Hey, name's Phil. I'm the receptionist here. It's terrible what happened.\"";
  }
  
  public void getTalk() {
    super.getTalk();
    addChoice(0, "Were you here last night?", "\"Nope. I always go home at five o' clock. No late nights for me!\"");
    addChoice(1, "What can you tell me\nabout the incident?", "\"We have a check-in system that keeps track of anyone going in or out. The record is on my computer.\nThat should tell you who was here and when last night.\"");
     if (password_status == 1) {
      addChoice(2, "What's the password to the computer?", "\"I haven't memorized it yet. It's on a note on my desk.\"");
    }
    if (password_status == 2) {
      addChoice(2, "When was Theodore\nMathson's dog born?", "\"I can't remember off the top of my head. I always go check that portrait in the paintings wing.\"");
    }
  }
}

class Paintings extends Person {
    Paintings(String filename) {
    super(filename);
    name = "Anne";
    height_ft = 5;
    height_in = 6;
    arms_ft = 7;
    arms_in = 4;
    foot_length_in = 9;
    char_weight = 143;
    desc = "That's Anne Lamarr. She's in charge of the paintings wing at the museum.";
    talk = "\"Hi there, I'm Anne. I'll help you anyway I can with your investigation.\"";
  }
  
  public void getTalk() {
    super.getTalk();
    addChoice(0, "Were you here last night?", "\"Yes, I was here late last night. But I was helping Francesca in the natural history wing bring in her bird.\nI didn't see anything.\"");
    if (password_status == 2) {
      addChoice(1, "When was Theodore\nMathson's dog born?", "\"I don't know, but we've got a painting of the Mathsons with their dog in this wing.\nMaybe that will help.\"");
    }
  }
}
  
class Modern extends Person {
    Modern(String filename) {
    super(filename);
      name = "Damien";
      height_ft = 6;
      height_in = 2;
      arms_ft = 8;
      arms_in = 4;
      foot_length_in = 9;
      char_weight = 190;
      desc = "That's Damien Wirst. He's a famous modern artist and is in charge of the modern art at the museum.";
      talk = "\"Oh, hello. I am called Damien Wirst. Perhaps you've heard of me.\nI am, after all, the artist behind these famous bronze legs. Be careful if you must examine them.\"";
    }
  
  public void getTalk() {
    super.getTalk();
    addChoice(0, "Were you here last night?", "\"No, I was not here at the time of the burglary. I must get plenty of rest each night to preserve my genius.\"");
    addChoice(1, "What is this stuff?", "\"This is art! Because I say it is!\"");
    addChoice(2, "Why would you build a copy\nof your own legs?", "\"Why wouldn't you, eh?\"");
    if (password_status == 2) {
      addChoice(3, "When was Theodore\nMathson's dog born?", "\"I do not know. I don't think time is real.\"");
    }
  }
}  

class Scientist extends Person {
   Scientist(String filename) {
    super(filename);
     name = "Francesca";
     height_ft = 5;
     height_in = 5;
     arms_ft = 7;
     arms_in = 1;
     foot_length_in = 6;
     char_weight = 140;
     desc = "That's Francesca Desantos, the scientist in charge of this wing.";
     talk = "\"Hi, I'm Francesca, the head scientist here. Have you checked out that footprint under the dinosaur skeleton?\"";
   }
   
   public void getTalk() {
     super.getTalk();
    addChoice(0, "Were you here last night?", "\"Yes. Anne from the paintings wing and I were bringing in this rare blue-beaked falcon.\"");
    if (password_status == 2) {
      addChoice(1, "When was Theodore\nMathson's dog born?", "\"Oh, I don't know. Can you carbon-date the dog? You can't? Then I'm no help here.\"");
    }
  }
}  

class GiftShop extends Person {
   GiftShop(String filename) {
    super(filename);
     name = "Larry";
     height_ft = 5;
     height_in = 11;
     arms_ft = 8;
     arms_in = 2;
     foot_length_in = 9;
     char_weight = 170;
     desc = "That's Larry Munk, the manager of the gift shop.";
     talk = "\"Hi. Name's Larry Munk. The shop's not open yet. Sorry if you wanted a souvenir.\"";
   }
   
   public void getTalk() {
     super.getTalk();
    addChoice(0, "Were you here last night?", "\"Yeah. But I was in here unpacking.\"");
    if (password_status == 2) {
      addChoice(1, "When was Theodore\nMathson's dog born?", "\"I didn't even know he had a dog. Beats me.\"");
    }
  }
}

class Security extends Person {
   Security(String filename) {
    super(filename);
     name = "Clem";
     height_ft = 6;
     height_in = 3;
     arms_ft = 8;
     arms_in = 7;
     foot_length_in = 8;
     char_weight = 210;
     desc = "That's Clem Jackson, the chief of security.";
     talk = "\"Hi, I'm Clem. The thief cut my security system, but that also stopped this clock here.\nSo the clock shows the time the burglary happened.\"";
   }
   
   public void getTalk() {
    super.getTalk();
    saw_clock = true;
    addChoice(0, "Were you here last night?", "\"Yeah, but that's my job. I'm the security chief. I found the ransom note and reported the burglary.\"");
    addChoice(1, "How did this happen if\nyou were on duty?", "\"I'm sorry. I went for a patrol at about midnight last night. I think I might have left the door open.\nWhoever did this deleted the video for yesterday and cut the wires to the system--and this clock, I guess.\"");
    addChoice(2, "What's up with this clock?", "\"That clock is actually wired to the security system. When the thief cut the wires, it stopped the clock.\nSo the clock shows the time when the system was cut.\"");
    if (password_status == 2) {
      addChoice(3, "When was Theodore\nMathson's dog born?", "\"What is this, a game show? I have no idea.\"");
    }
  }
} 

class Barista extends Person {
   Barista(String filename) {
    super(filename);
     name = "Sarah";
     height_ft = 5;
     height_in = 11;
     arms_ft = 8;
     arms_in = 1;
     foot_length_in = 10;
     char_weight = 167;
     desc = "That's Christine Lee, manager of the cafe.";
     talk = "\"Hey, I'm Christine. Have a cup of coffee if you like, detective.\"";
   }
   
   public void getTalk() {
     super.getTalk();
    addChoice(0, "Were you here last night?", "\"Nope. I need a good night's sleep.\"");
    addChoice(1, "You seem a little worried.", "\"Someone stole two of my donuts overnight. Don't worry about it, you have bigger crimes to solve.\"");
    if (password_status == 2) {
      addChoice(2, "When was Theodore\nMathson's dog born?", "\"How should I know?\"");
    }
  }
} 
public void setupReport(){
  cp5 = new ControlP5(this);
  PFont p = createFont("Courier New", 14);
  PFont big = createFont("Courier New", 24);
  
  report_tries = 0;
  
  cp5.setFont(big);
  
  items_label = cp5.addTextlabel("items_label")
  .setText("Which three objects are fake?")
  .setPosition(5,12)
  .setColorValue(color(0));
  
  suspects_label = cp5.addTextlabel("suspects_label")
  .setText("Who stole the items?")
  .setPosition(5,268)
  .setColorValue(color(0));
  
  cp5.setFont(p);
  
  items_checkbox = cp5.addCheckBox("items")
  .setPosition(5,50)
  .setItemsPerRow(3)
  .setSpacingColumn(300)
  .setColorLabel(color(0))
  .setSize(40, 40)
  .addItem("Mathson Family Portrait", 0)
  .addItem("The Knight of the Six Stars", 1)
  .addItem("Still Life", 2)
  .addItem("The Trial of Anne von Syne", 3)
  .addItem("Blue-Beaked Falcon", 4)
  .addItem("Algebrasaurus X", 5)
  .addItem("My Cube, My Sorrow", 6)
  .addItem("Half of Me", 7)
  .addItem("Metamorphosis", 8)
  .addItem("Parabolaen Coins", 9)
  .addItem("Chain of Asymptoth", 10)
  .addItem("Parabolaen Shield", 11)
  ;
  
  char_radio = cp5.addRadioButton("chars")
  .setPosition(5,300)
  .setItemsPerRow(3)
  .setSpacingColumn(300)
  .setColorLabel(color(0))
  .setSize(40, 40)
  .addItem("Angela St. Claire", 0)
  .addItem("Phil Rudolph", 1)
  .addItem("Anne LaMarr", 2)
  .addItem("Damien Wirst", 3)
  .addItem("Francesca Desantos", 4)
  .addItem("Joe Gill", 5)
  .addItem("Larry Munk", 6)
  .addItem("Christine Lee", 7)
  .addItem("Clem Jackson", 8)
  ;
  
  cp5.addButton("submit")
  .setPosition(800, 450)
  .setSize(95, 45)
  .setCaptionLabel("SUBMIT");
  
  cp5.hide();
    
}

public void submit(int theValue){
  if (!checkSubmission()){
    setStatus("", "You must pick three items you think are fake and accuse one suspect.");
  } else if (analyzeReport()) {
    report_tries++;
    goToRoom(ending);
  } else {
    report_tries++;
    setStatus("Your report was not correct. Go back and keep trying!","You have tried " + report_tries + " time(s).");
  }
}

//Returns true if the submission has 3 objects and a suspect
public boolean checkSubmission(){
  
  int count = 0; //Make sure three items are selected
  for (int i = 0; i <= 11; i++){
     if (items_checkbox.getState(i)) {
          count++;
      }
   }
   
   boolean suspect = false; //Make sure a suspect is accused
   for (int i = 0; i <= 8; i++) {
     if(char_radio.getState(i)){
        suspect = true;
      }
   }
   
   return (count == 3 && suspect);
}

public boolean analyzeReport(){
  
  int correct = 0;
           
  for (int i = 0; i <= 11; i++){
    if (items_checkbox.getState(i)) {
     String item_name = items_checkbox.getItem(i).getName();
       JOptionPane.showInputDialog(frame, "Explain why you think " + item_name + " is a fake.", "Make the Case!", JOptionPane.PLAIN_MESSAGE);
       if (i == 3 || i == 7 || i ==10) {
         JOptionPane.showMessageDialog(frame, "The crime lab has completed its analysis and you were right! "+ item_name + " is a fake!", "A Winner is You", JOptionPane.PLAIN_MESSAGE);
         correct++;
       } else {
          JOptionPane.showMessageDialog(frame, "The crime lab has completed its analysis and found that "+ item_name + " is not a fake. Go back and keep investigating.", "Oops.", JOptionPane.PLAIN_MESSAGE);
       }
     }
  }
        
  for (int i = 0; i <= 8; i++) {
    if(char_radio.getState(i)){
       String suspect_name = char_radio.getItem(i).getName();
       JOptionPane.showInputDialog(frame, "Explain why you think " + suspect_name + " is the burglar.", "Make the Case!", JOptionPane.PLAIN_MESSAGE);
       if (char_radio.getState(6)) {
         JOptionPane.showMessageDialog(frame, "You're right! It was Larry!", "A Winner is You", JOptionPane.PLAIN_MESSAGE);
         correct++;
       } else {
          JOptionPane.showMessageDialog(frame, "The police have interrogated " + suspect_name + " and your accusation was incorrect.\n" + suspect_name + " is very upset with you!", "Oops!", JOptionPane.PLAIN_MESSAGE);
       }
     }  
  }
  
  return (correct == 4);
}
//A Room is a collection of clickable items with a name.
//A Clickable is anything you can click. An object is a thing in the game with properties.
class Room {
  Clickable[] obj;
  String room_name;
  String announcement;
  String mathhint;
  int num_obj; //For bookkeeping and drawing
  boolean floor_line;
  boolean change_prev;
  int wall_color;
  int floor_color;
  boolean showGUI;
  
  Room(String name, boolean change, int w_color, int f_color, boolean show_gui){
    room_name = name;
    announcement = "";
    showGUI = show_gui;
    mathhint = "I don't see much right now, but we can always learn more by exploring, counting, measuring, and weighing things in the world around us.";
    obj = new Clickable[OBJ_LIMIT];
    num_obj = 0;
    floor_line = true;
    change_prev = change;
    wall_color = w_color;
    floor_color = f_color;
  }
  
  
  
  //This is called when the rooms are created to add the objects to the rooms.
  public void addObject(Clickable object, int x, int y){    
    obj[num_obj] = object;
    //println(room_name); //Uncomment to find problem objects
    obj[num_obj].clk_x = x;
    obj[num_obj].clk_y = y;
    num_obj++;
  }
  
  public void setAnnouncement(String announce){
    announcement = announce;
  }
  
  public void setMathHint(String hint){
    mathhint = hint;
  }
  
  public void noFloor(){
    floor_line = false;
  }
}

public void drawRoom(Room room){
  
  //Draw each object in the room at its coordinates
  for (int i = 0; i < room.num_obj; i++) {
    image(room.obj[i].getImage(), room.obj[i].getX(), room.obj[i].getY());
  }
  
}

//Goes to room
public void goToRoom(Room room){
  
  cp5.hide();
  clearChoices();
  
  if (cur_room.change_prev){ //Sets the previous room only for real rooms, not zoom-ins, otherwise loops can happen
    prev_room = cur_room;
  }
  
  cur_room = room;
  setStatus(cur_room.announcement);
  math_hint = (room.mathhint);
  surface.setTitle("Math Caper: " + room.room_name);
    
  if (room.floor_line) { //I have no idea why but this floor system can't just be in drawRoom, it needs to be global
    draw_floor = true;
  } else {
    draw_floor = false;
  }
  
  //If you put floor drawing anywhere in drawRoom, the line is in front of the objects
  //If you just reference the variable in the room, the line always draws
  //Who knows why?
}


class ExitX extends Clickable {
  ExitX (String filename){
    super(filename);
  }
  
  public void onClick() {
    goToRoom(prev_room);
  }
  
}
//Create the rooms, but leave them empty for now
public void createAllRooms(){
  
  intro = new Room("Introduction", false, 0xffffffff, 0xffffffff, false);
    intro.noFloor();
  crime = new Room("Caper Description", false, 0xffffffff, 0xffffffff, false);
    crime.noFloor();
  instructions = new Room("Instructions", false, 0xffffffff, 0xffffffff, true);
    instructions.noFloor();
  ending = new Room("Ending", false, 0xffffffff, 0xffffffff, false);
    ending.noFloor();
  lobby = new Room("Lobby", true, 0xffd9d9d9, 0xfff2f2f2, true);
    computer = new Room("Lobby Computer", true, 0xff6666ff, 0xff6666ff, true);
    email = new Room("Emails", false, computer.wall_color, computer.wall_color, true);
    supply_inventory = new Room("Supply Room Inventory List", false, computer.wall_color, computer.wall_color, true);
    check_in = new Room("Check-In Check-Out System", false, computer.wall_color, computer.wall_color, true);
      computer.noFloor();
      email.noFloor();
      supply_inventory.noFloor();
      check_in.noFloor();
  hallway = new Room("Hallway", true, 0xffd9d9d9, 0xfff2f2f2, true);
  paintings = new Room("Paintings Hall", true, 0xffd68f8f, 0xff8c8c8c, true);
    TrialRoom = new Room("The Trial of Anne Von Syne", false, paintings.wall_color, paintings.wall_color, true);
    StillLifeRoom = new Room("Still Life", false, paintings.wall_color, paintings.wall_color, true);
    PortraitRoom = new Room("Mathson Family Portrait", false, paintings.wall_color, paintings.wall_color, true);
    KnightRoom = new Room("The Knight of Six Stars", false, paintings.wall_color, paintings.wall_color, true);
      TrialRoom.noFloor();
      StillLifeRoom.noFloor();
      PortraitRoom.noFloor();
      KnightRoom.noFloor();    
  modern = new Room("Modern Art Gallery", true, 0xffC5D0DB, 0xffffffff, true);
    MetamorphosisRoom = new Room("Metamorphosis", false, modern.wall_color, modern.wall_color, true);
      MetamorphosisRoom.noFloor();
  relics = new Room("Artifacts Gallery", true, 0xff572Ad4, 0xff8c8c8c, true);
    CoinsRoom = new Room("Parabolean Coins", false, 0xffffffff, 0xffffffff, true);
      CoinsRoom.noFloor();
    ChainRoom = new Room("Chain of Asymptoth", false,  0xffffffff, 0xffffffff, true);
      ChainRoom.noFloor();
  natural_history = new Room("Hall of Natural History", true, 0xff128016, 0xff8c8c8c, true);
    NHFootprint = new Room("Footprint", false, 0xfffcff54, 0xfffcff54, true);
    NHFootprint.noFloor();
  security = new Room("Security Station", true, 0xff3c423d, 0xff8c8c8c, true);
  giftshop = new Room("Gift Shop", true, 0xffcc8fbe, 0xff8c8c8c, true);
  cafe = new Room("Cafe", true, 0xff8fccb3, 0xff8c8c8c, true);
  closet = new Room("Supply Closet", true, 0xff78733d, 0xff8c8c8c, true);
    SupplyFootprint = new Room("Footprint", false, closet.floor_color, closet.floor_color, true);
    SupplyFootprint.noFloor();
  FullFootprint = new Room("Footprint", false, 0xffffffff, 0xffffffff, true);
    FullFootprint.noFloor();
  Report = new Room("Case Report", false, 0xffffffff, 0xffffffff, true);
    Report.noFloor();
}

//Create ALL THE OBJECTS AND PEOPLE
public void createAllObjects() {
    
  //INTRO
  introtext = new Door("IntroText.png", crime, "");
  crimetext = new Door("CrimeText.png", instructions, "");
  instructionstext = new ExitX("Instructions.png");
  endingtext = new Door("EndingText.png", lobby, "");
  
  //GENERAL
  ExitToHallway = new Door("HallwaySign.png", hallway, "footstep");
  LobbyDoor = new Door("LobbySignRight.png", lobby, "footstep");
  LobbyDoorLeft = new Door("LobbySignLeft.png", lobby, "footstep");
  exitX = new ExitX("ExitX.png");
  oNHFullFootprint = new NHFootprintScreen("NHFootprint.png");
  oSupplyFullFootprint = new SupplyFootprintScreen("SupplyFootprint.png");
  inchOverlap = new Inch("InchOverlap.png");
  
  //LOBBY
  oDesk = new Desk("Desk2.png");
  oComputer = new Computer("Computer2.png");
  pDirector = new Director("Director.png");
  pReceptionist = new Receptionist("Receptionist.png");
  LobbyHallwayDoor = new Door("HallwayDoorfromLobby.png", hallway, "footstep");
  GiftShopDoor = new Door("GiftShopSign.png", giftshop, "footstep");
  CafeDoor = new Door("CafeSign.png", cafe, "footstep");
  
    //LOBBY COMPUTER
    emailIcon = new Door("EmailIcon.png", email, "");
    checkInIcon = new Door("CheckInIcon.png", check_in, "");
    inventoryIcon = new Door("SupplyIcon.png", supply_inventory, "");
    computerExit = new Door("ExitX.png", lobby, "");
    oEmail = new EmailScreen("Email.png");
    oCheckIn = new CheckInScreen("EntryLog.png");
    oSupplyInventory = new InventoryScreen("SupplyInventory.png");
  
  //HALLWAY
  ModernArtDoor = new Door("ModernArtDoor.png", modern, "footstep");
  PaintingsDoor = new Door("PaintingsDoor.png", paintings, "footstep");
  RelicsDoor = new Door("RelicsDoor.png", relics, "footstep");
  NaturalHistoryDoor = new Door("NaturalHistoryDoor.png", natural_history, "footstep");
  
  //PAINTINGS
  pPaintings = new Paintings("Paintings.png");
  oMathsonPortrait = new MathsonPortrait("PortraitWall.png");
  oKnightPainting = new KnightPainting("KnightWall.png");
  oStillLife = new StillLife("StillLifeWall.png");
  oTrialPainting = new TrialPainting("TrialWall.png");
  oPortraitArt = new PortraitArt("PortraitScreen.png");
  oKnightArt = new KnightArt("KnightScreen.png");
  oStillLifeArt = new StillLifeArt("StillLife.png");
  oTrialArt = new TrialArt("Trial.png");
  
  //MODERN
  pModern = new Modern("ModernArtist.png");
  oCube = new Cube("Cube2.png");
  oMetamorphosis = new Metamorphosis("MetamorphosisWall.png");
  oLegs = new Legs("Legs.png");
  oMetamorphosisArt = new MetamorphosisArt("MetamorphosisScreen.png");
  
  //RELICS
  oChain = new Chain("Necklace.png");
  oCoins = new Coins("Coins.png");
  oShield = new Shield("Shield.png");
  oSign = new Sign("Sign2.png");
  oCoinsScreen = new CoinsScreen("CoinsScreen.png");
  oChainScreen = new ChainScreen("ChainScreen.png");
  
  //NATURAL HISTORY
  pScientist = new Scientist("Scientist.png");
  oBird = new Bird("Bird.png");
  oDinosaur = new Dinosaur("Dinosaur.png");
  oDinoFloor = new DinoFloor("DinoFloor2.png");
  SecurityDoor = new Door("SecurityDoor.png", security, "door");
  oNHFootprint = new NHFootprintScreen("NHFootprint.png");
  
  //SECURITY
  pSecurity = new Security("SecurityGuard.png");
  oClock = new Clock("Clock2.png");
  oTerminal = new Terminal("SecurityTerminal2.png");
  oGarbage = new Garbage("Trash2.png");
  oWires = new Wires("Wires.png");
  SecurityExit = new Door("NaturalHistoryDoorFromSec.png", natural_history, "door");
  
  //GiftShop
  pGiftShop = new GiftShop("GiftShopManager.png");
  oRegister = new Register("Register2.png");
  oCounter = new Counter("GiftCounter2.png");
  oModelDinosaur = new ModelDinosaur("DinosaurModel2.png");
  oMinicube = new Minicube("CubeModel2.png");
  oPoster = new Poster("KnightWall.png");
  
  //Cafe
  pBarista = new Barista("CafeManager.png");
  oChair1 = new Chair("LeftChair2.png");
  oChair2 = new Chair("RightChair2.png");
  oCafeTable = new CafeTable("Table2.png");
  oCafeCounter = new CafeCounter("CafeCounter2.png");
  SupplyDoor = new Door("SupplyDoor.png", closet, "door");
  
  //Supply Closet
  SupplyExit = new Door("SupplyExit.png", cafe, "door");
  oMop1 = new Mop("Mop2.png");
  oMop2 = new Mop("Mop3.png");
  oBucket = new Bucket("Bucket.png");
  oPuddle = new Puddle("Puddle2.png");
  oStepladder = new Stepladder("Stepladder2.png");
  oHammer = new Hammer("Hammer2.png");
  oScrewdriver = new Screwdriver("Screwdriver2.png");
  oWrench = new Wrench("Wrench2.png");
  oHook = new Hook("Hooks.png");
  oSupplyFootprint = new SupplyFootprintScreen("SupplyFootprint.png");
  
   
}

//Put everything in the rooms
public void addObjectsToRooms() {
  
  intro.addObject(introtext, 5, 5);
  crime.setAnnouncement("Caper #1: \"Two Plus Two is Forgery\"\n\nConceived, programmed, and written by Marc Campasano\nArt by John Flanagan and Rachel Jane Andelman\nMusic by Jon Fuller");
  crime.addObject(crimetext, 5, 5);
  instructions.addObject(instructionstext, 5, 5);
  instructions.setAnnouncement("Game instructions");
  ending.addObject(endingtext, 5, 5);
  ending.setAnnouncement("You did it!");
  
  FullFootprint.addObject(oNHFullFootprint, 425, 200);
  FullFootprint.addObject(oSupplyFullFootprint, 200, 5);
  FullFootprint.addObject(exitX, 825, 5);
  FullFootprint.addObject(inchOverlap, 700, 200);
  FullFootprint.setAnnouncement("You've found both parts of a full footprint. It looks like there's one inch of overlap between them.");
  FullFootprint.setMathHint("There's one inch of overlap between the two footprints. If we subtract the overlap from the total length, that's the length of the foot.");
  oNHFullFootprint.mathhint = FullFootprint.mathhint;
  oSupplyFullFootprint.mathhint = FullFootprint.mathhint;
  
  lobby.setAnnouncement("You are in the lobby of the Mathsonian Museum of Art and Science.");
  lobby.addObject(LobbyHallwayDoor, 300, 80);
  lobby.addObject(oDesk, 540, 310);
  lobby.addObject(oComputer, 700, 285);
  lobby.addObject(pDirector, 30, 210);
  lobby.addObject(pReceptionist, 190, 230);
  lobby.addObject(GiftShopDoor, 5, 5);
  lobby.addObject(CafeDoor, 790, 5);
  
  computer.setAnnouncement("Using the password, you access Phil's front desk computer.\n\nThis information has all been added to your clue menu so you can reread it at any time.");
  computer.setMathHint("There's a lot of data here. Take a look in the files to see what there is to learn.");
  computer.addObject(emailIcon, 50, 50);
  computer.addObject(checkInIcon, 150, 50);
  computer.addObject(inventoryIcon, 250, 50);
  computer.addObject(computerExit, 825, 5);
  email.setAnnouncement(oEmail.desc);
  email.setMathHint("Joe Gill, the history director, says he's sick. Does that match the attendance record on this computer?");
  email.addObject(oEmail, 5, 5);
  email.addObject(exitX, 825, 5);
  check_in.setAnnouncement(oCheckIn.desc);
  check_in.setMathHint("Now this is helpful! If we knew what time the burglary happened last night, this would tell us who was there at the same time.");
  check_in.addObject(oCheckIn, 5, 5);
  check_in.addObject(exitX, 825, 5);
  supply_inventory.setAnnouncement(oSupplyInventory.desc);
  supply_inventory.setMathHint("So this is what should be in the supply closet. Is everything there?");
  supply_inventory.addObject(oSupplyInventory, 5, 5);
  supply_inventory.addObject(exitX, 825, 5);
  
  hallway.setAnnouncement("This is the hallway to all the exhibits.");
  hallway.addObject(ModernArtDoor, 25, 128);
  hallway.addObject(PaintingsDoor, 240, 124);
  hallway.addObject(RelicsDoor, 455, 132);
  hallway.addObject(NaturalHistoryDoor, 670, 129);
  hallway.addObject(LobbyDoor, 790, 5);
  
  paintings.setAnnouncement("This is the Mathson Foundation's famous paintings collection.");
  paintings.setMathHint("If the thief wasn't very careful, maybe a forged painting wouldn't exactly match its official description.");
  paintings.addObject(pPaintings, 50, 210);
  paintings.addObject(oMathsonPortrait, 200, 100);
  paintings.addObject(oKnightPainting, 615, 100);
  paintings.addObject(oStillLife, 775, 180);
  paintings.addObject(oTrialPainting, 615, 260);
  PortraitRoom.addObject(oPortraitArt, 75, 15);
  PortraitRoom.addObject(exitX, 825, 5);
  PortraitRoom.setMathHint(oMathsonPortrait.mathhint);
  PortraitRoom.setAnnouncement(oMathsonPortrait.desc);
  KnightRoom.addObject(oKnightArt, 250, 15);
  KnightRoom.addObject(exitX, 825, 5);
  KnightRoom.setMathHint(oKnightPainting.mathhint);
  KnightRoom.setAnnouncement(oKnightPainting.desc);
  StillLifeRoom.addObject(oStillLifeArt, 200, 25);
  StillLifeRoom.setAnnouncement(oStillLife.desc);
  StillLifeRoom.setMathHint(oStillLife.mathhint);
  StillLifeRoom.addObject(exitX, 825, 5);
  TrialRoom.addObject(oTrialArt, 40, 100);
  TrialRoom.setAnnouncement(oTrialPainting.desc);
  TrialRoom.setMathHint(oTrialPainting.mathhint);
  TrialRoom.addObject(exitX, 825, 5);
  paintings.addObject(ExitToHallway, 790, 10);
  
  modern.setAnnouncement("This is the modern art wing. It's a little weird. But it's trendy!");
  modern.setMathHint("Let's see what we can measure about this...um...art.");
  modern.addObject(pModern, 100, 200);
  modern.addObject(oCube, 300, 325);
  modern.addObject(oLegs, 580, 300);
  modern.addObject(oMetamorphosis, 425, 130);
  MetamorphosisRoom.addObject(oMetamorphosisArt, 25, 75);
  MetamorphosisRoom.setMathHint(oMetamorphosisArt.mathhint);
  MetamorphosisRoom.setAnnouncement(oMetamorphosisArt.desc);
  MetamorphosisRoom.addObject(exitX, 825, 5);
  modern.addObject(ExitToHallway, 790, 10);
  
  relics.setAnnouncement("This is a special exhibit about an ancient people called the Parabolae.");
  relics.addObject(oSign, 100, 240);
  relics.addObject(oChain, 350, 250);
  relics.addObject(oCoins, 550, 250);
  relics.addObject(oShield, 700, 250);
  relics.addObject(ExitToHallway, 700, 10);
  CoinsRoom.addObject(oCoinsScreen, 75, 100);
  CoinsRoom.addObject(exitX, 825, 5);
  CoinsRoom.setAnnouncement(oCoinsScreen.desc);
  CoinsRoom.setMathHint(oCoinsScreen.mathhint);
  ChainRoom.addObject(oChainScreen, 5, 5);
  ChainRoom.addObject(exitX, 830, 5);
  ChainRoom.setAnnouncement(oChainScreen.desc);
  ChainRoom.setMathHint(oChainScreen.mathhint);
  
  natural_history.setAnnouncement("This is the natural history wing.");
  natural_history.addObject(pScientist, 10, 220);
  natural_history.addObject(oBird, 170, 275);
  natural_history.addObject(oDinoFloor, 375, 400);
  natural_history.addObject(oDinosaur, 310, 105);
  natural_history.addObject(ExitToHallway, 790, 10);
  natural_history.addObject(SecurityDoor, 725, 162);
  NHFootprint.addObject(oNHFootprint, 200, 100);
  NHFootprint.addObject(exitX, 825, 5);
  NHFootprint.setAnnouncement(oNHFootprint.desc);
  NHFootprint.setMathHint(oNHFootprint.mathhint);
  
  security.setAnnouncement("This is the museum's security center.");
  security.setMathHint("Those wires are cut, but they're way off the ground! The thief must have stood on something, and had something to cut with...hmm...\nI bet it would help if you modeled this with a drawing.");
  security.addObject(pSecurity, 200, 200);
  security.addObject(oClock, 325, 100);
  security.addObject(oTerminal, 500, 100);
  security.addObject(oGarbage, 425, 380);
  security.addObject(oWires, 0, 0);
  security.addObject(SecurityExit, 10, 162);
  
  giftshop.setAnnouncement("You are in the museum gift shop. Department policy says you can't buy things while on duty.");
  giftshop.addObject(oCounter, 10, 300);
  giftshop.addObject(oRegister, 175, 238);
  giftshop.addObject(pGiftShop, 280, 250);
  giftshop.addObject(oModelDinosaur, 450, 300);
  giftshop.addObject(oPoster, 500, 150);
  giftshop.addObject(oMinicube, 700, 350);
  giftshop.addObject(LobbyDoor, 790, 10);
  
  cafe.setAnnouncement("This is the museum's cafe.");
  cafe.addObject(SupplyDoor, 300, 163);
  cafe.addObject(pBarista, 10, 225);
  cafe.addObject(oChair1, 150, 350);
  cafe.addObject(oCafeTable, 250, 350);
  cafe.addObject(oChair2, 375, 350);
  cafe.addObject(oCafeCounter, 500, 275);
  cafe.addObject(LobbyDoorLeft, 5, 5);
  
  closet.setAnnouncement("You're in the museum supply closet.");
  closet.addObject(SupplyExit, 10, 162);
  closet.addObject(oPuddle, 330, 400);
  closet.addObject(oMop2, 300, 300);
  closet.addObject(oMop1, 275, 255);
  closet.addObject(oBucket, 500, 375);
  closet.addObject(oStepladder, 600, 360);
  closet.addObject(oHammer, 650, 250);
  closet.addObject(oScrewdriver, 700, 250);
  closet.addObject(oWrench, 745, 250);
  closet.addObject(oHook, 800, 270);
  SupplyFootprint.addObject(oSupplyFootprint, 200, 100);
  SupplyFootprint.addObject(exitX, 825, 5);
  SupplyFootprint.setAnnouncement(oSupplyFootprint.desc);
  SupplyFootprint.setMathHint(oSupplyFootprint.mathhint);
  
  Report.setAnnouncement("Pick which three items you think are forgeries and who you think the burglar is.\nThen click SUBMIT to send your report to the department!");
  Report.addObject(exitX, 825, 5);
    
}
  public void settings() {  size(1200, 600); }
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "MathDetective" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
