final int OBJ_LIMIT = 30;
final int WINDOW_WIDTH = 1200; //Need to update this manually at setup
final int WINDOW_HEIGHT = 600;

import javax.swing.JOptionPane;
import ddf.minim.*;
import controlP5.*;

boolean MouseControl = false;
Minim minim;
AudioPlayer music, stepsound, doorsound;

ControlP5 cp5;
CheckBox items_checkbox;
RadioButton char_radio;
Textlabel items_label;
Textlabel suspects_label;
int report_tries;

String status;
String status2;
String cur_tool;
String math_hint;
boolean draw_floor;
PFont status_font;

Choice[] choiceArray;
int[] choiceX;

//Game flow
int password_status; //0 = new quest; 1 = noted locked computer; 2 = found dog clue; 3 = unlocked
int footprint_status; //0 = no footprint; 1 = NH only; 2 = supply only; 3 = both found;
boolean saw_clock;
boolean saw_wires;

Room prev_room;
Room cur_room;

Room GUI; //The GUI is actually just a room that is accessed differently -- but it's still just a collection of objects
MathHintButton oMathHintButton;
CaseHintButton oCaseHintButton;
Door IntroButton;
ReportButton oReportButton;
Inch  inchOverlap;

Room lobby;  //Main rooms
Room hallway;
Room paintings;
Room modern;
Room relics;
Room natural_history;
Room security;
Room closet;
Room giftshop;
Room cafe;
Room ending;

Room intro; //Minor rooms
Room crime;
Room instructions;
Room computer;
Room email;
Room supply_inventory;
Room check_in;
Room KnightRoom;
Room TrialRoom;
Room StillLifeRoom;
Room PortraitRoom;
Room MetamorphosisRoom;
Room CoinsRoom;
Room ChainRoom;
Room NHFootprint;
Room SupplyFootprint;
Room FullFootprint;
Room Map;
Room Report;

Object cur_object;

//Intro texts -- actually just giant doors to the next text room
Door introtext;
Door crimetext;
Door endingtext;
ExitX instructionstext; //This is an ExitX so that clicking through it always goes to prev room
ExitX exitX; //The universal "go to previous room" X

//GUI
LensButton lensButton;
TalkButton talkButton;
MeasureButton measureButton;
WeighButton weighButton;
Door emailIconGUI;
Door inventoryIconGUI;
Door checkInIconGUI;
Door footprintGUI;
NHFootprintScreen oNHFullFootprint;
SupplyFootprintScreen oSupplyFullFootprint;
Door mapButton;
MapScreen oMapScreen;

//Lobby
Desk oDesk;
Computer oComputer;
Door LobbyHallwayDoor;
Door LobbyDoor;
Door LobbyDoorLeft;
Door GiftShopDoor;
Door CafeDoor;

//Hallway
Door ExitToHallway;
Door ModernArtDoor;
Door RelicsDoor;
Door PaintingsDoor;
Door NaturalHistoryDoor;

//Lobby computer
Door emailIcon;
Door inventoryIcon;
Door checkInIcon;
Door computerExit;
EmailScreen oEmail;
InventoryScreen oSupplyInventory;
CheckInScreen oCheckIn;

//Paintings
MathsonPortrait oMathsonPortrait;
KnightPainting oKnightPainting;
StillLife oStillLife;
TrialPainting oTrialPainting;
PortraitArt oPortraitArt;
KnightArt oKnightArt;
StillLifeArt oStillLifeArt;
TrialArt oTrialArt;

//Modern
Cube oCube;
Metamorphosis oMetamorphosis;
Legs oLegs;
MetamorphosisArt oMetamorphosisArt;

//Relics
Chain oChain;
Coins oCoins;
Shield oShield;
Sign oSign;
CoinsScreen oCoinsScreen;
ChainScreen oChainScreen;

//Natural History
Bird oBird;
Dinosaur oDinosaur;
DinoFloor oDinoFloor;
Door SecurityDoor;
NHFootprintScreen oNHFootprint;

//Security
Clock oClock;
Garbage oGarbage;
Wires oWires;
Terminal oTerminal;
Door SecurityExit;

//Supply closet
Door SupplyExit;
Mop oMop1;
Mop oMop2;
Puddle oPuddle;
Bucket oBucket;
Stepladder oStepladder;
Hammer oHammer;
Screwdriver oScrewdriver;
Wrench oWrench;
Hook oHook;
SupplyFootprintScreen oSupplyFootprint;

//Gift shop
Counter oCounter;
ModelDinosaur oModelDinosaur;
Poster oPoster;
Minicube oMinicube;
Register oRegister;

//Cafe
Chair oChair1;
Chair oChair2;
CafeTable oCafeTable;
Coffee oCoffee;
CafeCounter oCafeCounter;
Door SupplyDoor;

//People
Director pDirector;
Receptionist pReceptionist;
Paintings pPaintings;
Modern pModern;
Scientist pScientist;
Security pSecurity;
Barista pBarista;
GiftShop pGiftShop;

PImage GlassCursor, TalkCursor, MeasureCursor, WeighCursor, ChoiceIcon;


void setup() {
  
  password_status = 0;
  footprint_status = 0;
  saw_clock = false;
  draw_floor = false;
  saw_wires = false;
  
  GlassCursor = loadImage("/images/GlassCursor.png");
  TalkCursor = loadImage("/images/TalkCursor.png");
  MeasureCursor = loadImage("/images/MeasureCursor.png");
  WeighCursor = loadImage("/images/WeighCursor.png");
  ChoiceIcon = loadImage("/images/ChoiceIcon.png");
  
  surface.setTitle("Math Caper: Introduction");
  cur_tool = "lens";
  cursor(GlassCursor, 0, 0);
  minim = new Minim(this);
  music = minim.loadFile("MathCaperMusicV3.mp3");
  stepsound = minim.loadFile("Footstep.mp3");
  doorsound = minim.loadFile("DoorSound.mp3");
  music.loop();
  size(1200, 600);
  prepareChoices();
  createAllRooms();
  createAllObjects();
  addObjectsToRooms();
  setupGUI();
  setupReport();
  status_font = createFont("Lucida Sans", 12);
  textFont(status_font);
  setStatus("Welcome to Math Caper!");
  prev_room = lobby;
  cur_room = intro;
}

void draw() {
  background(255);
    
  noStroke();
  fill(cur_room.wall_color);
  rect(0,0,900,400);
  fill(cur_room.floor_color);
  rect(0,400,900,100);
  
  stroke(0);
  strokeWeight(1);
  if (draw_floor) {
    line(0,400,900,400); //Floor line
  }
  
  strokeWeight(2);
  line(WINDOW_WIDTH * .75 ,0,WINDOW_WIDTH * .75,WINDOW_HEIGHT); //Window is 900x500
  line(0,WINDOW_HEIGHT-100,WINDOW_WIDTH,WINDOW_HEIGHT-100);
  
  drawRoom(cur_room);
  drawChoices();
  if (cur_room.showGUI) {
    drawRoom(GUI);
  }
  fill(0);
  text(status,10,520);
  fill(#0000ff);
  text(status2, 10, 540);
  fill(0);
}

//Outputs to the game's text console
void setStatus(String msg){
  status = msg;
  status2 = "";
}

void setStatus(String msg, String msg2){
  status = msg;
  status2 = msg2;
}

void clearStatus(){
  setStatus("", "");
}
