

class Desk extends Object{
   
  Desk(String filename) {
    super(filename);
    clk_width /= 2; //The width is halved so clicking the computer won't trigger the desk.
    desc = "The front desk of the museum. There's a note on the desk: COMPUTER PASSWORD IS THE YEAR THEODORE MATHSON'S DOG WAS BORN";
    measure = "The desk is 30 inches tall, 48 inches wide, and 28 inches deep.";
    weigh = "The desk is too big to weigh on your small scale.";
   }
   
    void getDesc(){
      super.getDesc();
      if (password_status <= 2) {
        password_status = 2;
        setStatus(status, "You should ask around about the dog's birthday.");
      }
    }
    
}

class Computer extends Object{
   
  Computer(String filename) {
    super(filename);
    desc = "It's locked with a password.";
    measure = "The monitor is 12 inches tall and 16 inches wide. The keyboard is 16 inches wide and 8 inches deep.";
    weigh = "The computer monitor weighs 7.2 pounds. The keyboard weighs 1.2 pounds.";
   }
   
    void getDesc(){
      super.getDesc();
      if (password_status < 3) {
        String password = JOptionPane.showInputDialog(frame, "Enter password:", "Password Required", JOptionPane.PLAIN_MESSAGE);
        if (password != null && password.equals("1891")) {
          goToRoom(computer);
          password_status = 3;
          GUI.addObject(emailIconGUI, 900, 400);
          GUI.addObject(checkInIconGUI, 1000, 400);
          GUI.addObject(inventoryIconGUI, 1100, 400);
        } else {
          setStatus("Incorrect password. Access denied.");
          if (password_status == 0) {
            password_status = 1;
            setStatus(status, "You should ask about the password.");
          }
        }
      } else {
        goToRoom(computer);
      }
    }
    
}

class EmailScreen extends Object {
  
  EmailScreen(String filename) {
    super(filename);
    desc = "This is Phil's email account. Don't worry, you can snoop. It's your job.\n\nYou may reread this at any time from the clue menu at right.";
    measure = "The monitor is 12 inches tall and 16 inches wide.";
    weigh = "The computer monitor weighs 7.2 pounds.";
  }
  
}

class InventoryScreen extends Object {
  
  InventoryScreen(String filename) {
    super(filename);
    desc = "This is a list of what should be in the supply closet.\n\nYou may reread this at any time from the clue menu at right.";
    measure = "The monitor is 12 inches tall and 16 inches wide.";
    weigh = "The computer monitor weighs 7.2 pounds.";
  }
  
}

class CheckInScreen extends Object {
  
  CheckInScreen(String filename) {
    super(filename);
    desc = "It's a record of everyone who's been in and out of the museum.\n\nYou may reread this at any time from the clue menu at right.";
    measure = "The monitor is 12 inches tall and 16 inches wide.";
    weigh = "The computer monitor weighs 7.2 pounds.";
  }
  
}

class MathsonPortrait extends PortraitArt {
  
  MathsonPortrait(String filename) {
    super(filename);
  }
  
   void getDesc() {
    goToRoom(PortraitRoom);
  }
  
}

class PortraitArt extends Object{
   PortraitArt(String filename) {
    super(filename);
    desc = "\"Mathson Family Portrait\" by Octavia Grey. 66 inches wide x 45 inches tall, acrylic on canvas, painted in 1903.\nThis portrait of our museum's namesake family was painted in honor of their dog Happy's twelfth birthday.\nTheodore and Annabelle Mathson appear with Happy and their 3 daughters Lauren, Clara, and Peg in their mansion sitting room.";
    measure = "The portrait is 5 feet 6 inches feet wide and 3 feet 9 inches feet tall.";
    weigh = "The portrait is much too big to weigh on your scale.";
    mathhint = "Huh. Looks like Theodore Mathson's dog turned 12 years old in 1903.";
  }
}

class KnightPainting extends KnightArt {
  
  KnightPainting(String filename) {
    super(filename);
  }
  
  void getDesc() {
    goToRoom(KnightRoom);
  }
  
}

class KnightArt extends Object {
  KnightArt(String filename) {
    super(filename);
    desc = "\"The Knight of the Six Stars\" by Edgar Plumm. 24 in x 24 in, oil on canvas, painted in 1754.\nThis portrays the medieval legend of the Knight of the Six Stars, who protected the English village of Brownstones from bandits.\nHere he sits on his horse Comet, prepared to assault a bandit lair. The Knight was named for the six stars on his shield, armor, and banner.\nPlumm drew twice as a many stars in the night sky to commemorate the Knight's ancestors who provided the same protection before him.";
    measure = "The painting is 2 feet wide and 2 feet tall.";
    weigh = "The painting weighs 4.8 pounds.";
    mathhint = "So he's the Knight of SIX stars, and there should be TWICE as many in the sky. TWICE means we multiply by two...";
  }
}

class StillLife extends StillLifeArt {
  
  StillLife(String filename) {
    super(filename);
  }
  
   void getDesc() {
    goToRoom(StillLifeRoom);
  }
}

class StillLifeArt extends Object {
  StillLifeArt(String filename) {
    super(filename);
    desc = "\"Still Life\" by Lizbeth Hamm. 10 inches each side, acrylic on canvas, painted in 1802.\nAn early Hamm still-life in the classic fruit bowl tradition.\nThe apple represents wisdom, the pear stands for growth,\nand there are half as many green grapes as red to represent the passage from youth to adulthood.";
    measure = "The painting is 10 inches tall and 10 inches wide.";
    weigh = "The painting weighs 3.1 pounds.";
    mathhint = "There should be half as many green grapes as red grapes. So there should be twice as many red grapes.";
  }
}

class TrialPainting extends TrialArt {
  
  TrialPainting(String filename) {
    super(filename);
  }
  
   void getDesc() {
    goToRoom(TrialRoom);
  }
   
}

class TrialArt extends Object {
  TrialArt(String filename) {
    super(filename);
    desc = "\"The Trial of Anne von Syne\" by Margot the Younger. 40 inches wide x 15 inches tall, oil on canvas, painted in 1467.\nAnne von Syne before the court of Angveld, waiting to be judged for stealing the king's bread to feed her son.\nThe people around her are King Herbert of Angveld, Queen Angela of Angveld, their six court guards,\nthree judicial counselors, the bailiff and the sheriff, and nine royal magistrates.";
    measure = "The painting is 3 feet 4 inches wide and 1 foot 3 inches tall.";
    weigh = "The painting weighs 5.1 pounds.";
    mathhint = "I can't really tell who is who in this painting. But we can count how many there are! One, two, three...";
  }
}

class Cube extends Object {
  
  Cube(String filename) {
    super(filename);
    desc = "\"My Cube, My Sorrow\" by Melodia Hogwash. Plastic (1998).\nHogwash poured 216 cubic feet of plastic into a mold to create this mysterious block. She says it was inspired by her father, somehow.";
    measure = "The cube is 6 feet wide, 6 feet tall, and 6 feet deep.";
    weigh = "The cube is too heavy to lift onto your scale.";
    mathhint = "Cubic feet is the amount of volume, right? The volume of a cube is length times width times height, if I remember geometry class right.";
  }
}

class Metamorphosis extends MetamorphosisArt {
  
  Metamorphosis(String filename) {
    super(filename);
  }
  
  void getDesc(){
    goToRoom(MetamorphosisRoom);
  }
}

class MetamorphosisArt extends Object {
  MetamorphosisArt(String filename){
    super(filename);
    desc = "\"Metamorphosis\" by Bernadette Le Poisson. Acrylic on canvas (2012). 25 in wide x 15 in tall. \nThe artist drew herself transforming into a fire hydrant over the course of eight hours. Le Poisson insists it represents her memory, somehow.";
    measure = "The painting is 2 feet 1 inch wide and 1 foot 3 inches tall.";
    weigh = "The painting weighs 4.9 pounds.";
    mathhint = "She starts at about 9:20, and finishes changing 8 hours later...wait, can we talk about how weird this painting is?";
  }
}

class Legs extends Object {
  
  Legs(String filename) {
    super(filename);
    desc = "\"Half of Me\" by Damien Wirst. Bronze (2016).\nWirst constructed these models of his own legs. They are, as advertised, half his height and, together, half his weight.\nWirst says that the piece is intended to feel \"apart, and yet whole,\" somehow.";
    measure = "Each leg is 3 feet 1 inch tall.";
    weigh = "The left leg weighs 47.5 pounds, and the right leg weighs 36.2 pounds.";
  }
}

class Chain extends ChainScreen {
  Chain(String filename) {
    super(filename);
  }
  
  void getDesc(){
    goToRoom(ChainRoom);
  }
}

class ChainScreen extends Object {
 ChainScreen(String filename){
   super(filename);
   desc =  "The chain of King Asymptoth, who ruled Parabolia from 499-534 AD. Each of the 17 links in this 19-inch chain weighs 0.2 pounds!\nThat's because they're made of pure parabolite, a very heavy mineral.\nKing Asymptoth wore it at all times as a symbol of his strength--at the cost of his posture." ;
   measure = "The chain is 1 foot 7 inches long.";
   weigh = "The whole chain weighs 4.1 pounds.";
   mathhint = "Is there the right number of links in the chain? Is it the right length?\nAnd what about the weight? If each of 17 links weighs 0.2 pounds, and we multiply...";
  }
}

class Coins extends CoinsScreen {
  Coins(String filename) {
    super(filename);
  }
  
  void getDesc(){
    goToRoom(CoinsRoom);
  }
}

class CoinsScreen extends Object {
  CoinsScreen(String filename) {
    super(filename);
    desc = "Parabolaen coins, c. 525 AD. The numbers on the coins tell their value. Together these coins were worth 53 units of currency.";
    measure = "Each coin is a circle 1 inch across.";
    weigh = "Each coin weighs only 0.02 pounds.";
    mathhint = "The key on the right tells us how much each coin is worth. They should be worth 53 all together, so we add their values...";
  }
}

class Shield extends Object {
  Shield(String filename) {
    super(filename);
    desc =  "A shield used by a Parabolaen warrior. This 10-square-foot shield was lightweight (only 7-8 pounds) but sturdy enough for deflecting enemy arrows.";
    measure = "The shield is 2 feet wide and 5 feet tall.";
    weigh = "The shield weighs 7.7 pounds.";
    mathhint = "Have you checked the weight of the shield? And the area? The shield is a rectangle, so the area should just be base times height.";
  }
}

class Sign extends Object {
  Sign(String filename) {
    super(filename);
    desc = "The sign says \"The Parabolae were an ancient civilization that founded the modern nation of Parabolia some 1500 years ago.\nThe Mathson collection is proud to present this collection of relics, recently uncovered by archaeologists.\"";
    measure = "The sign is 6 feet 3 inches tall and 2 feet 1 inch wide.";
    weigh = "The sign weighs 11.2 pounds.";
  }
}

class Bird extends Object {
   Bird (String filename) {
    super(filename);
     desc = "A rare Blue-beaked falcon, now sadly extinct. This fearsome bird could weigh up to 25 pounds, and each of its wings could be up to 2 feet long!";
     measure = "The falcon's wingspan is 3 feet 6 inches. It's 20 inches tall.";
     weigh = "The falcon weighs 21.4 pounds.";
     mathhint = "If each wing could be upto two feet long, then together the wingspan should be twice that--at most, that is.";
   }
}

class Dinosaur extends Object {
  Dinosaur(String filename) {
    super(filename);
    desc = "Algebrasaurus X lived 80 million years ago. It could grow to be over 20 feet tall and weighed up to 5,000 pounds!";
    measure = "The dinosaur skeleton is 23 feet and 5 inches tall. Wow!";
    weigh = "You definitely can't weigh something that big.";
    mathhint = "It would be fun to measure this, but, to be honest, I sincerely doubt the burglar faked an entire dinosaur.";
  }
}

class DinoFloor extends Object {
  DinoFloor(String filename) {
    super(filename);
    desc = "This is the dinosaur display area. There's half a footprint next to one of the rocks in the sand.";
    measure = "The dinosaur display area is 20 feet across.";
    weigh = "You try to weigh the ground. You quickly realize that that doesn't work.";
  }
  
  void getDesc() {
   goToRoom(NHFootprint); 
    
    if (footprint_status == 0){
      footprint_status = 1;
      footprintGUI.destination = NHFootprint;
      GUI.addObject(footprintGUI, 1100, 300);
      setStatus(NHFootprint.announcement, "You may view the footprint from the menu to your right.");
    } else if (footprint_status == 2){
      footprint_status = 3;
      footprintGUI.destination = FullFootprint;
    }
    
    if (footprint_status == 3) {
      setStatus(NHFootprint.announcement, "You may view the FULL footprint from the menu to your right.");
    }
  }
}

class NHFootprintScreen extends Object {
  NHFootprintScreen(String filename) {
    super(filename);
    desc = "It's the back of an incomplete footprint in the sand of the dinosaur display.";
    measure = "This piece of the footprint is 5.7 inches long.";
    weigh = "You can't weigh a footprint.";
    mathhint = "We can measure this, but that doesn't help when we've only got part of a footprint.";
  }
}

class ModelDinosaur extends Object {
  ModelDinosaur(String filename) {
    super(filename);
    desc = "That's a 1/10 scale model of the Algebrasaurus X.";
    measure = "The model is a little over 28 inches tall.";
    weigh = "The model weighs 4.2 pounds.";
    mathhint = "A 1/10 scale model should be one-tenth the height of the real thing.";
  }
}

class Poster extends Object {
  Poster(String filename) {
    super(filename);
    desc = "That's a poster of the \"Knight of the Six Stars\" painting.";
    measure = "The poster is 2 feet on each side.";
    weigh = "The poster only weighs 0.2 pounds.";
  }
}

class Minicube extends Object {
  Minicube(String filename) {
    super(filename);
    desc = "Those are miniature models of the cube in the modern art gallery.";
    measure = "The cubes are 2 inches on each side.";
    weigh = "A cube weighs 0.05 pounds.";
  }
}

class Mug extends Object {
  Mug(String filename) {
    super(filename);
    desc = "A mug with the museum logo on it.";
    measure = "The mug is 5 inches tall and 3 inches across.";
    weigh = "The mug weighs 0.2 pounds.";
  }
}

class Register extends Object {
  Register(String filename) {
    super(filename);
    desc = "It's a cash register. There's no money inside.";
    measure = "The register is 1 foot 11 inches tall.";
    weigh = "The register weighs 15.3 pounds.";
  }
}

class Counter extends Object {
    Counter(String filename) {
    super(filename);
    desc = "It's a counter. For doing business, not for counting. That's your job, detective.";
    measure = "The counter is 4 feet 2 inches tall.";
    weigh = "The counter is firmly attached to the ground.";
  }
}

class Wires extends Object {
  Wires(String filename) {
    super(filename);
    desc = "There are wires along the ceiling connected to the security terminal. It looks like they've been cut!";
    measure = "You extend your measuring tape very long and find that the wires are 14 feet off the ground.";
    weigh = "You can't weigh something stuck to the ceiling.";
  }
  
  void getDesc(){
    setStatus("There are wires along the ceiling connected to the security terminal. It looks like they've been cut!", "The wires are very high off the ground. The burglar must have reached upward to cut these wires.\nYou can now measure suspects with their arms reaching upward.");
  }
  
  void onClick() {
    super.onClick();
    saw_wires = true;
  }
}

class Clock extends Object {
  Clock(String filename) {
    super(filename);
    desc = "It's a wall clock wired into the wall. It looks like it's stopped.";
    measure = "The clock is 1 foot 6 inches across.";
    weigh = "The clock is wired into the wall. You can't take it down to weigh.";
  }
}

class Garbage extends Object {
  Garbage(String filename) {
    super(filename);
    desc = "It's a garbage pail. There are two paper wrappers inside with sugar crumbs.";
    measure = "The pail is 1 foot 8 inches tall. Its brim is 1 foot 1 inch across.";
    weigh = "The garbage pail weighs 1.2 pounds.";
  }
}

class Terminal extends Object {
  Terminal(String filename) {
    super(filename);
    desc = "It's a complicated security system. It looks like it's broken.";
    measure = "The system is 10 feet 2 inches tall.";
    weigh = "You can't weigh something so big.";
  }
}

class Mop extends Object {
  Mop(String filename) {
    super(filename);
    desc = "It's a mop.";
    measure = "The mop is 5 feet long.";
    weigh = "The mop weighs 4.3 pounds.";
  }
}

class Stepladder extends Object {
  Stepladder(String filename) {
    super(filename);
    desc = "It's a step ladder.";
    measure = "The step ladder is 3 feet tall.";
    weigh = "The step ladder weighs 6.5 pounds.";
  }
}

class Bucket extends Object {
  Bucket(String filename) {
    super(filename);
    desc = "It's a bucket for cleaning floors.";
    measure = "The bucket is 2 feet 2 inches tall and 1 foot 6 inches across.";
    weigh = "The bucket weighs 3.8 pounds.";
  }
}

class Puddle extends Object {
  Puddle(String filename) {
    super(filename);
    desc = "There's a puddle of water under that mop. There's a bit of a footprint sticking out.";
    measure = "The puddle is about 2 feet 3 inches across.";
    weigh = "You try to weigh the puddle. Your scale gets all wet.";
  }
  
  void getDesc() {
    goToRoom(SupplyFootprint);
    
    if (footprint_status == 0){
      footprint_status = 2;
      footprintGUI.destination = SupplyFootprint;
      GUI.addObject(footprintGUI, 1100, 300);
      setStatus(SupplyFootprint.announcement, "You may view the footprint from the menu to your right.");
    } else if (footprint_status == 1){
      footprint_status = 3;
      footprintGUI.destination = FullFootprint;
    }
    
    if (footprint_status == 3) {
      setStatus(SupplyFootprint.announcement, "You may view the FULL footprint from the menu to your right.");
    }
  }
  
}

class SupplyFootprintScreen extends Object {
  SupplyFootprintScreen(String filename) {
    super(filename);
    desc = "It's the front of an incomplete footprint next to the puddle on the floor.";
    measure = "This piece of the footprint is 4.3 inches long.";
    weigh = "You can't weigh a footprint.";
    mathhint = "We can measure this, but that doesn't help when we've only got part of a footprint.";
  }
}

class Hammer extends Object {
  Hammer(String filename) {
    super(filename);
    desc = "A hammer hangs on the wall.";
    measure = "The hammer is 11 inches long.";
    weigh = "The hammer weighs 1.8 pounds.";
  }
}

class Screwdriver extends Object {
  Screwdriver(String filename) {
    super(filename);
    desc = "It's a screwdriver hanging on the wall.";
    measure = "The screwdriver is 8 inches long.";
    weigh = "The screwdriver weighs 0.56 pounds.";
  }
}

class Wrench extends Object {
  Wrench(String filename) {
    super(filename);
    desc = "There's a wrench hanging on the wall.";
    measure = "The wrench is 1 foot 3 inches long.";
    weigh = "The wrench weighs 3.2 pounds.";
  }
}

class Hook extends Object {
  Hook(String filename) {
    super(filename);
    desc = "There's a hook with nothing on it.";
    measure = "The hook sticks out 2 inches.";
    weigh = "You can't weigh a hook stuck in the wall.";
  }
}

class CafeTable extends Object {
  CafeTable(String filename) {
    super(filename);
    desc = "It's a table for eating at the cafe.";
    measure = "The table is 2 feet 6 inches tall. Its surface is a 3-foot square.";
    weigh = "The table weighs 14.34 pounds.";
  }
}

class Chair extends Object {
  Chair(String filename) {
    super(filename);
    desc = "It's a chair for eating. (For eating food, not the chair.)";
    measure = "The chair is 3 feet tall.";
    weigh = "The chair weighs 10.3 pounds.";
  }
}

class Coffee extends Object {
  Coffee(String filename) {
    super(filename);
    desc = "It's a canister for coffee. It's pretty hot!";
    measure = "The coffee canister is 2 feet 4 inches tall.";
    weigh = "You try to weigh the canister but just spill coffee instead.";
  }
}

class CafeCounter extends Object {
  CafeCounter(String filename) {
    super(filename);
    desc = "It's the cafe counter, full of all sorts of treats.";
    measure = "The counter is 8 feet long and 4 feet tall.";
    weigh = "You try to weigh the counter. You can't, so you weigh a piece of toast instead. It's 0.03 pounds.";
  }
}

class MapScreen extends Object {
  MapScreen(String filename) {
    super(filename);
    desc = "This is the map of the museum.";
    measure = "The map is 6 inches by 6 inches.";
    weigh = "The paper map doesn't even register on your scale.";
  }
}

class Inch extends Clickable {
  Inch(String filename) {
    super(filename);
  }
  
  void onClick(){
    setStatus("There's an inch of overlap between the footprints.");
  }
}
    
