class Person extends Object {
    String talk;
    String name;
    int height_ft;
    int height_in;
    int arms_ft;
    int arms_in;
    int foot_length_in;
    int char_weight;
    
    Person(String filename) {
    super(filename);
      talk = "";
    }
    
    void onClick(){
      if (cur_tool == "talk") {
        clearChoices();
        getTalk();
      } else {
        super.onClick();
      }
    }
    
    void getTalk() {
      setStatus(talk);
    }
    
    void getMeasure() {
      setStatus("How would you like to measure " + name + "?");
      addChoice(0, "Measure height from head to toe", name + " is " + height_ft + " feet and " + height_in + " inches tall.");
      
      if (footprint_status > 0) {
        addChoice(1, "Measure foot length", name + "'s foot is " + foot_length_in + " inches long.\nIt's not the same pattern as the footprint.");
      }
      if (saw_wires) {
        addChoice(2, "Measure height with arms reaching up", name + " is " + arms_ft + " feet and " + arms_in + " inches tall when they reach with their arms.");
      }
    }
    
    void getWeigh(){
      setStatus(name + " weighs " + char_weight + " pounds.");
    }
    
}

class Director extends Person {
  
  Director(String filename) {
    super(filename);
    name = "Angela";
    height_ft = 6;
    height_in = 1;
    arms_ft = 8;
    arms_in = 5;
    foot_length_in = 10;
    char_weight = 172;
    desc = "That's Angela St. Claire, the director of the Mathsonian museum. She's in charge of everything here.";
    talk = "\"Thank goodness you're here. I'm Angela St. Claire, director here at the museum. I'll help in any way I can.\"";
  }
  
  void getTalk() {
    super.getTalk();
    addChoice(0, "Were you here last night?", "\"I was here late last night. I left at about midnight. I didn't see anything, though.\"");
    addChoice(1, "What can you tell me\nabout the incident?", "\"Only the museum workers have been in or out of the building. Our building has a system that requires us to log in or out whenever we leave.\nThe record is on Phil's computer here in the lobby. Since there was no break-in, I bet that could help.\"");
    if (password_status == 1) {
      addChoice(2, "What's the password to the computer?", "\"I'm not sure. It's Phil's computer, not mine.\"");
    }
    if (password_status == 2) {
      addChoice(2, "When was Theodore\nMathson's dog born?", "\"Oh, I don't know. Sometime in the 1800s, I guess.\"");
    }
  }
  
}

class Receptionist extends Person {
    Receptionist(String filename) {
    super(filename);
    name = "Phil";
    height_ft = 5;
    height_in = 8;
    arms_ft = 7;
    arms_in = 9;
    foot_length_in = 9;
    char_weight = 180;
    desc = "That's Phil Rudolph, the front desk receptionist at the museum.";
    talk = "\"Hey, name's Phil. I'm the receptionist here. It's terrible what happened.\"";
  }
  
  void getTalk() {
    super.getTalk();
    addChoice(0, "Were you here last night?", "\"Nope. I always go home at five o' clock. No late nights for me!\"");
    addChoice(1, "What can you tell me\nabout the incident?", "\"We have a check-in system that keeps track of anyone going in or out. The record is on my computer.\nThat should tell you who was here and when last night.\"");
     if (password_status == 1) {
      addChoice(2, "What's the password to the computer?", "\"I haven't memorized it yet. It's on a note on my desk.\"");
    }
    if (password_status == 2) {
      addChoice(2, "When was Theodore\nMathson's dog born?", "\"I can't remember off the top of my head. I always go check that portrait in the paintings wing.\"");
    }
  }
}

class Paintings extends Person {
    Paintings(String filename) {
    super(filename);
    name = "Anne";
    height_ft = 5;
    height_in = 6;
    arms_ft = 7;
    arms_in = 4;
    foot_length_in = 9;
    char_weight = 143;
    desc = "That's Anne Lamarr. She's in charge of the paintings wing at the museum.";
    talk = "\"Hi there, I'm Anne. I'll help you anyway I can with your investigation.\"";
  }
  
  void getTalk() {
    super.getTalk();
    addChoice(0, "Were you here last night?", "\"Yes, I was here late last night. But I was helping Francesca in the natural history wing bring in her bird.\nI didn't see anything.\"");
    if (password_status == 2) {
      addChoice(1, "When was Theodore\nMathson's dog born?", "\"I don't know, but we've got a painting of the Mathsons with their dog in this wing.\nMaybe that will help.\"");
    }
  }
}
  
class Modern extends Person {
    Modern(String filename) {
    super(filename);
      name = "Damien";
      height_ft = 6;
      height_in = 2;
      arms_ft = 8;
      arms_in = 4;
      foot_length_in = 9;
      char_weight = 190;
      desc = "That's Damien Wirst. He's a famous modern artist and is in charge of the modern art at the museum.";
      talk = "\"Oh, hello. I am called Damien Wirst. Perhaps you've heard of me.\nI am, after all, the artist behind these famous bronze legs. Be careful if you must examine them.\"";
    }
  
  void getTalk() {
    super.getTalk();
    addChoice(0, "Were you here last night?", "\"No, I was not here at the time of the burglary. I must get plenty of rest each night to preserve my genius.\"");
    addChoice(1, "What is this stuff?", "\"This is art! Because I say it is!\"");
    addChoice(2, "Why would you build a copy\nof your own legs?", "\"Why wouldn't you, eh?\"");
    if (password_status == 2) {
      addChoice(3, "When was Theodore\nMathson's dog born?", "\"I do not know. I don't think time is real.\"");
    }
  }
}  

class Scientist extends Person {
   Scientist(String filename) {
    super(filename);
     name = "Francesca";
     height_ft = 5;
     height_in = 5;
     arms_ft = 7;
     arms_in = 1;
     foot_length_in = 6;
     char_weight = 140;
     desc = "That's Francesca Desantos, the scientist in charge of this wing.";
     talk = "\"Hi, I'm Francesca, the head scientist here. Have you checked out that footprint under the dinosaur skeleton?\"";
   }
   
   void getTalk() {
     super.getTalk();
    addChoice(0, "Were you here last night?", "\"Yes. Anne from the paintings wing and I were bringing in this rare blue-beaked falcon.\"");
    if (password_status == 2) {
      addChoice(1, "When was Theodore\nMathson's dog born?", "\"Oh, I don't know. Can you carbon-date the dog? You can't? Then I'm no help here.\"");
    }
  }
}  

class GiftShop extends Person {
   GiftShop(String filename) {
    super(filename);
     name = "Larry";
     height_ft = 5;
     height_in = 11;
     arms_ft = 8;
     arms_in = 2;
     foot_length_in = 9;
     char_weight = 170;
     desc = "That's Larry Munk, the manager of the gift shop.";
     talk = "\"Hi. Name's Larry Munk. The shop's not open yet. Sorry if you wanted a souvenir.\"";
   }
   
   void getTalk() {
     super.getTalk();
    addChoice(0, "Were you here last night?", "\"Yeah. But I was in here unpacking.\"");
    if (password_status == 2) {
      addChoice(1, "When was Theodore\nMathson's dog born?", "\"I didn't even know he had a dog. Beats me.\"");
    }
  }
}

class Security extends Person {
   Security(String filename) {
    super(filename);
     name = "Clem";
     height_ft = 6;
     height_in = 3;
     arms_ft = 8;
     arms_in = 7;
     foot_length_in = 8;
     char_weight = 210;
     desc = "That's Clem Jackson, the chief of security.";
     talk = "\"Hi, I'm Clem. The thief cut my security system, but that also stopped this clock here.\nSo the clock shows the time the burglary happened.\"";
   }
   
   void getTalk() {
    super.getTalk();
    saw_clock = true;
    addChoice(0, "Were you here last night?", "\"Yeah, but that's my job. I'm the security chief. I found the ransom note and reported the burglary.\"");
    addChoice(1, "How did this happen if\nyou were on duty?", "\"I'm sorry. I went for a patrol at about midnight last night. I think I might have left the door open.\nWhoever did this deleted the video for yesterday and cut the wires to the system--and this clock, I guess.\"");
    addChoice(2, "What's up with this clock?", "\"That clock is actually wired to the security system. When the thief cut the wires, it stopped the clock.\nSo the clock shows the time when the system was cut.\"");
    if (password_status == 2) {
      addChoice(3, "When was Theodore\nMathson's dog born?", "\"What is this, a game show? I have no idea.\"");
    }
  }
} 

class Barista extends Person {
   Barista(String filename) {
    super(filename);
     name = "Sarah";
     height_ft = 5;
     height_in = 11;
     arms_ft = 8;
     arms_in = 1;
     foot_length_in = 10;
     char_weight = 167;
     desc = "That's Christine Lee, manager of the cafe.";
     talk = "\"Hey, I'm Christine. Have a cup of coffee if you like, detective.\"";
   }
   
   void getTalk() {
     super.getTalk();
    addChoice(0, "Were you here last night?", "\"Nope. I need a good night's sleep.\"");
    addChoice(1, "You seem a little worried.", "\"Someone stole two of my donuts overnight. Don't worry about it, you have bigger crimes to solve.\"");
    if (password_status == 2) {
      addChoice(2, "When was Theodore\nMathson's dog born?", "\"How should I know?\"");
    }
  }
} 
