void setupReport(){
  cp5 = new ControlP5(this);
  PFont p = createFont("Courier New", 14);
  PFont big = createFont("Courier New", 24);
  
  report_tries = 0;
  
  cp5.setFont(big);
  
  items_label = cp5.addTextlabel("items_label")
  .setText("Which three objects are fake?")
  .setPosition(5,12)
  .setColorValue(color(0));
  
  suspects_label = cp5.addTextlabel("suspects_label")
  .setText("Who stole the items?")
  .setPosition(5,268)
  .setColorValue(color(0));
  
  cp5.setFont(p);
  
  items_checkbox = cp5.addCheckBox("items")
  .setPosition(5,50)
  .setItemsPerRow(3)
  .setSpacingColumn(300)
  .setColorLabel(color(0))
  .setSize(40, 40)
  .addItem("Mathson Family Portrait", 0)
  .addItem("The Knight of the Six Stars", 1)
  .addItem("Still Life", 2)
  .addItem("The Trial of Anne von Syne", 3)
  .addItem("Blue-Beaked Falcon", 4)
  .addItem("Algebrasaurus X", 5)
  .addItem("My Cube, My Sorrow", 6)
  .addItem("Half of Me", 7)
  .addItem("Metamorphosis", 8)
  .addItem("Parabolaen Coins", 9)
  .addItem("Chain of Asymptoth", 10)
  .addItem("Parabolaen Shield", 11)
  ;
  
  char_radio = cp5.addRadioButton("chars")
  .setPosition(5,300)
  .setItemsPerRow(3)
  .setSpacingColumn(300)
  .setColorLabel(color(0))
  .setSize(40, 40)
  .addItem("Angela St. Claire", 0)
  .addItem("Phil Rudolph", 1)
  .addItem("Anne LaMarr", 2)
  .addItem("Damien Wirst", 3)
  .addItem("Francesca Desantos", 4)
  .addItem("Joe Gill", 5)
  .addItem("Larry Munk", 6)
  .addItem("Christine Lee", 7)
  .addItem("Clem Jackson", 8)
  ;
  
  cp5.addButton("submit")
  .setPosition(800, 450)
  .setSize(95, 45)
  .setCaptionLabel("SUBMIT");
  
  cp5.hide();
    
}

void submit(int theValue){
  if (!checkSubmission()){
    setStatus("", "You must pick three items you think are fake and accuse one suspect.");
  } else if (analyzeReport()) {
    report_tries++;
    goToRoom(ending);
  } else {
    report_tries++;
    setStatus("Your report was not correct. Go back and keep trying!","You have tried " + report_tries + " time(s).");
  }
}

//Returns true if the submission has 3 objects and a suspect
boolean checkSubmission(){
  
  int count = 0; //Make sure three items are selected
  for (int i = 0; i <= 11; i++){
     if (items_checkbox.getState(i)) {
          count++;
      }
   }
   
   boolean suspect = false; //Make sure a suspect is accused
   for (int i = 0; i <= 8; i++) {
     if(char_radio.getState(i)){
        suspect = true;
      }
   }
   
   return (count == 3 && suspect);
}

boolean analyzeReport(){
  
  int correct = 0;
           
  for (int i = 0; i <= 11; i++){
    if (items_checkbox.getState(i)) {
     String item_name = items_checkbox.getItem(i).getName();
       JOptionPane.showInputDialog(frame, "Explain why you think " + item_name + " is a fake.", "Make the Case!", JOptionPane.PLAIN_MESSAGE);
       if (i == 3 || i == 7 || i ==10) {
         JOptionPane.showMessageDialog(frame, "The crime lab has completed its analysis and you were right! "+ item_name + " is a fake!", "A Winner is You", JOptionPane.PLAIN_MESSAGE);
         correct++;
       } else {
          JOptionPane.showMessageDialog(frame, "The crime lab has completed its analysis and found that "+ item_name + " is not a fake. Go back and keep investigating.", "Oops.", JOptionPane.PLAIN_MESSAGE);
       }
     }
  }
        
  for (int i = 0; i <= 8; i++) {
    if(char_radio.getState(i)){
       String suspect_name = char_radio.getItem(i).getName();
       JOptionPane.showInputDialog(frame, "Explain why you think " + suspect_name + " is the burglar.", "Make the Case!", JOptionPane.PLAIN_MESSAGE);
       if (char_radio.getState(6)) {
         JOptionPane.showMessageDialog(frame, "You're right! It was Larry!", "A Winner is You", JOptionPane.PLAIN_MESSAGE);
         correct++;
       } else {
          JOptionPane.showMessageDialog(frame, "The police have interrogated " + suspect_name + " and your accusation was incorrect.\n" + suspect_name + " is very upset with you!", "Oops!", JOptionPane.PLAIN_MESSAGE);
       }
     }  
  }
  
  return (correct == 4);
}
