//A Room is a collection of clickable items with a name.
//A Clickable is anything you can click. An object is a thing in the game with properties.
class Room {
  Clickable[] obj;
  String room_name;
  String announcement;
  String mathhint;
  int num_obj; //For bookkeeping and drawing
  boolean floor_line;
  boolean change_prev;
  color wall_color;
  color floor_color;
  boolean showGUI;
  
  Room(String name, boolean change, color w_color, color f_color, boolean show_gui){
    room_name = name;
    announcement = "";
    showGUI = show_gui;
    mathhint = "I don't see much right now, but we can always learn more by exploring, counting, measuring, and weighing things in the world around us.";
    obj = new Clickable[OBJ_LIMIT];
    num_obj = 0;
    floor_line = true;
    change_prev = change;
    wall_color = w_color;
    floor_color = f_color;
  }
  
  
  
  //This is called when the rooms are created to add the objects to the rooms.
  void addObject(Clickable object, int x, int y){    
    obj[num_obj] = object;
    //println(room_name); //Uncomment to find problem objects
    obj[num_obj].clk_x = x;
    obj[num_obj].clk_y = y;
    num_obj++;
  }
  
  void setAnnouncement(String announce){
    announcement = announce;
  }
  
  void setMathHint(String hint){
    mathhint = hint;
  }
  
  void noFloor(){
    floor_line = false;
  }
}

void drawRoom(Room room){
  
  //Draw each object in the room at its coordinates
  for (int i = 0; i < room.num_obj; i++) {
    image(room.obj[i].getImage(), room.obj[i].getX(), room.obj[i].getY());
  }
  
}

//Goes to room
void goToRoom(Room room){
  
  cp5.hide();
  clearChoices();
  
  if (cur_room.change_prev){ //Sets the previous room only for real rooms, not zoom-ins, otherwise loops can happen
    prev_room = cur_room;
  }
  
  cur_room = room;
  setStatus(cur_room.announcement);
  math_hint = (room.mathhint);
  surface.setTitle("Math Caper: " + room.room_name);
    
  if (room.floor_line) { //I have no idea why but this floor system can't just be in drawRoom, it needs to be global
    draw_floor = true;
  } else {
    draw_floor = false;
  }
  
  //If you put floor drawing anywhere in drawRoom, the line is in front of the objects
  //If you just reference the variable in the room, the line always draws
  //Who knows why?
}


class ExitX extends Clickable {
  ExitX (String filename){
    super(filename);
  }
  
  void onClick() {
    goToRoom(prev_room);
  }
  
}
